class Castle
{
  static clicks_castle_entrance()
  {
    document.getElementById('game-panels-combat-items-area-castle').style.display = '';
    document.getElementById('game-panels-combat-items-area-select').style.display = 'none';
    Castle.toggle_faradox_background(true)
    Castle.refresh_map();
  }
  static exit()
  {
    document.getElementById('game-panels-combat-items-area-castle').style.display = 'none';
    document.getElementById('game-panels-combat-items-area-select').style.display = '';
    Castle.toggle_faradox_background(false)
  }

  static toggle_faradox_background(b)
  {
    if(b)
    {
      document.getElementById("panel-combat").style.backgroundImage = 'url(https://cdn.idle-pixel.com/images/map_castle_background.png)'
    }
    else 
    {
      document.getElementById("panel-combat").style.backgroundImage = ''
    }
  }

  static refresh_map()
  {
    websocket.send('LOAD_CASTLE_MAP')
  }

  static hide_map_entities()
  {
      var ids = [
        "castle-map-1-arrow",
        "castle-map-2-arrow-1",
        "castle-map-2-arrow-2",
        "castle-map-3-arrow-1",
        "castle-map-3-arrow-2",
        "castle-map-3-arrow-3",
        "castle-map-4-arrow",
        "castle-map-5-arrow-1",
        "castle-map-5-arrow-2",
        "castle-map-6-arrow-1",
        "castle-map-6-arrow-2",
        "castle-map-7-arrow-1",
        "castle-map-7-arrow-2",
        "castle-map-7-arrow-3",
        "castle-map-8-arrow-1",
        "castle-map-9-arrow-1",
        "castle-map-9-arrow-2",
        "castle-map-10-arrow-1",
        "castle-map-10-arrow-2",
        "castle-map-11-arrow-1",
        "castle-map-14-arrow",
        "castle-map-14-arrow-2",
        "castle-map-14-arrow-3",
        "castle-map-15-arrow",
        "castle-map-18-arrow-2",
        "castle-key-1",
        "castle-key-2",

        "castle-map-20-arrow",
        "castle-map-20-arrow-1",
        "castle-map-20-arrow-2",
        "castle-map-20-arrow-3",

        "castle-map-21-arrow",
        "castle-map-21-arrow-1",
        "castle-map-21-arrow-2",
        "castle-map-21-arrow-3",

        "castle-map-22-arrow",
        "castle-map-22-arrow-1",
        "castle-map-22-arrow-2",
        "castle-map-22-arrow-3",

        "castle-map-23-arrow",
        "castle-map-23-arrow-1",
        "castle-map-23-arrow-2",
        "castle-map-23-arrow-3",

        "castle-map-24-arrow",
        "castle-map-24-arrow-1",
        "castle-map-24-arrow-2",
        "castle-map-24-arrow-3",

        "castle-map-25-arrow",
        "castle-map-25-arrow-1",
        "castle-map-25-arrow-2",
        "castle-map-25-arrow-3",

        "castle-map-26-arrow",
        "castle-map-26-arrow-1",
        "castle-map-26-arrow-2",
        "castle-map-26-arrow-3",
        "castle-map-26-arrow-4",
        "castle-map-26-arrow-5",
        "castle-map-26-arrow-6",
        "castle-map-26-arrow-7",
        "castle-map-26-arrow-8",
        "castle-map-26-arrow-9",
        "castle-map-26-arrow-10",

        "castle-map-29-arrow",

        "castle-map-28-arrow",
        "castle-map-28-dad_goblin",
        "castle-map-28-portal",
        "castle-map-28-dad_goblin_notes",

        "castle-map-29-portal",

        "castle-map-27-arrow",
        "castle-map-27-arrow-2",

        "castle-map-19-arrow",
        "castle-map-19-arrow-2",

        "castle-bubble-1",
        "castle-bubble-2",

        "castle-map-stange-leaf-tree",

        "castle-ants",
        "castle-yeti",
        "castle-saltwater-crocodile",

        "castle-map-green-ball",
        "castle-map-red-ball",
        "castle-map-blue-ball",

        "castle-map-28-arrow-1",

        "castle-wizard-1",
        "castle-map-merchant",

        "castle-map-16-chest",
        "castle-map-17-arrow",

        "castle-dead-dwarf",
        "castle-dead-combat-tutor",

        "castle-rock-statue",
        "castle-rock-statue-sad",
        "castle-rock-awake",

        "pressure-plate-1",

        "castle-bubble-skull-1",

        "castle-map-7-portal",
        "castle-map-12-portal",

        "castle-map-12-arrow",

        "castle-map-13-arrow",
        "castle-map-13-arrow-2",
        "castle-13-quiz-arrow-up",
        "castle-13-quiz-arrow-down",
        "castle-13-quiz-arrow-left",
        "castle-13-quiz-arrow-right",
        
        "castle-30-quiz-arrow-up",
        "castle-30-quiz-arrow-down",
        "castle-30-quiz-arrow-left",
        "castle-30-quiz-arrow-right",

        "castle-map-13-chest",

        "castle-map-14-hiddenarrow-1",

        "castle-map-15-arrow-2",

        "castle-map-16-arrow",
        "castle-map-18-arrow",
        "castle-bubble-3",

        "castle-map-30-arrow-1",
        "castle-30-chest",
        "castle-map-30-arrow-2",

        "castle-map-31-monoculars",
        "castle-map-31-arrow-1",
        "castle-map-31-arrow-2",
        "castle-map-31-arrow-3",

        "castle-map-32-arrow-1",
        "castle-map-32-train-dead",

        "castle-map-33-arrow-1",
        "castle-map-33-arrow-2",
        "castle-map-33-bubble-1",
        "castle-map-33-bubble-2",
        "castle-map-33-bubble-3",
        "castle-map-33-bubble-4",
        "castle-map-33-bubble-5",

        "castle-map-34-arrow-1",
        "castle-map-34-arrow-2",
        "castle-map-34-bubble-1",
        
        "castle-map-35-arrow-1",
        "castle-map-35-arrow-2",

        "castle-map-36-arrow-1",
        "castle-map-36-faradox",
        "castle-map-36-forest_crystal_final_touched",
        "castle-map-36-earth_crystal_final_touched",
        "castle-map-36-ice_crystal_final_touched",
        "castle-map-36-fire_crystal_final_touched",

        "castle_hole",

        "castle-map-37-arrow-1",
        "castle-map-37-bubble-1",
      ]


      for(var i = 0; i < ids.length; i++) {
        document.getElementById(ids[i]).style.display = "none";
      }
      
  }


  static clicks_dungeon_castle_tomb() {
    var has_green_gaurdian_key = Items.getItem("green_gaurdian_key") > 0;
    var has_blue_gaurdian_key = Items.getItem("blue_gaurdian_key") > 0;
    var has_purple_gaurdian_key = Items.getItem("purple_gaurdian_key") > 0;
    var has_energy = Items.getItem("energy") >= 100000;

    var testingFor = "";

    testingFor = "modal-castle-dungeon-tomb-energy-needed";
    if(has_energy) document.getElementById(testingFor).style.color = "green"; else document.getElementById(testingFor).style.color = "red";
    
    

    testingFor = "modal-castle-dungeon-tomb-greenkey-needed"
    if(has_green_gaurdian_key) document.getElementById(testingFor).style.color = "green"; else document.getElementById(testingFor).style.color = "red";
    testingFor = "modal-castle-dungeon-tomb-bluekey-needed"
    if(has_blue_gaurdian_key) document.getElementById(testingFor).style.color = "green"; else document.getElementById(testingFor).style.color = "red";
    testingFor = "modal-castle-dungeon-tomb-purplekey-needed"
    if(has_purple_gaurdian_key) document.getElementById(testingFor).style.color = "green"; else document.getElementById(testingFor).style.color = "red";
    
    Modals.toggle('modal-castle-dungeon-tomb');
  }

  static load_map(id)
  {
      Castle.hide_map_entities();
      if(id == 37) 
        set_image_src("castle-map", "images/castle_map_" + id + "_cache.png");
      else
        set_image_src("castle-map", "images/castle_map_" + id + ".png");

      if(id == 1)
      {
          document.getElementById("castle-map-1-arrow").style.display = "";
      }
      if(id == 2)
      {
          document.getElementById("castle-map-2-arrow-1").style.display = "";
          document.getElementById("castle-map-2-arrow-2").style.display = "";
          document.getElementById("castle-bubble-1").style.display = "";

          if(Items.getItem("castle_key_1_picked_up") > 0)
            document.getElementById("castle-key-1").style.display = "none";
          else
            document.getElementById("castle-key-1").style.display = "";

          if(Items.getItem("castle_key_1_used") > 0)
              document.getElementById("castle-map-2-arrow-2").src = "https://cdn.idle-pixel.com/images/arrow_up.png";
      }
      if(id == 3)
      {
          document.getElementById("castle-map-3-arrow-1").style.display = "";
          document.getElementById("castle-map-3-arrow-2").style.display = "";
          document.getElementById("castle-map-3-arrow-3").style.display = "";
          document.getElementById("pressure-plate-1").style.display = "";

          if(Items.getItem("castle_key_2_used") > 0)
              document.getElementById("castle-map-3-arrow-3").src = "https://cdn.idle-pixel.com/images/arrow_up.png";

          if(Items.getItem("pressure_plate_1_used") > 0)
            document.getElementById("pressure-plate-1").style.display = "none";
      }
      if(id == 4)
      {
          document.getElementById("castle-map-4-arrow").style.display = "";

          if(Items.getItem("strange_leaf_tree_picked_up") == 0)
            document.getElementById("castle-map-stange-leaf-tree").style.display = "";
          else
            document.getElementById("castle-map-stange-leaf-tree").style.display = "none";

          if(Items.getItem("castle_key_2_picked_up") > 0)
            document.getElementById("castle-key-2").style.display = "none";
          else
            document.getElementById("castle-key-2").style.display = "";
      }
      if(id == 5)
      {
        document.getElementById("castle-map-5-arrow-1").style.display = "";
        document.getElementById("castle-map-5-arrow-2").style.display = "";
        document.getElementById("castle-ants").style.display = "";

        if(Items.getItem("castle_ants_kills") > 0)
        {
          document.getElementById("castle-ants").style.display = "none";
        }
        
        if(Items.getItem("castle_key_3_used") > 0)
              document.getElementById("castle-map-5-arrow-2").src = "https://cdn.idle-pixel.com/images/arrow_up.png";
      }

      if(id == 6)
      {
        document.getElementById("castle-map-6-arrow-1").style.display = "";
        document.getElementById("castle-map-6-arrow-2").style.display = "";
        document.getElementById("castle-bubble-2").style.display = "";

        if(Items.getItem("green_ball_picked_up") == 0) document.getElementById("castle-map-green-ball").style.display = "";
        if(Items.getItem("red_ball_picked_up") == 0)  document.getElementById("castle-map-red-ball").style.display = "";
        if(Items.getItem("blue_ball_picked_up") == 0)  document.getElementById("castle-map-blue-ball").style.display = "";

        if(Items.getItem("castle_quiz_1_completed") > 0)
              document.getElementById("castle-map-6-arrow-2").src = "https://cdn.idle-pixel.com/images/arrow_up.png";
      }
      if(id == 7)
      {
        document.getElementById("castle-map-7-arrow-1").style.display = "";
        document.getElementById("castle-map-7-arrow-2").style.display = "";
        document.getElementById("castle-map-7-arrow-3").style.display = "";
        
        document.getElementById("castle-wizard-1").style.display = "";

        if(Items.getItem("clicks_wizard_1_found") == 1)
        {
          document.getElementById("castle-wizard-1").style.display = "none";
        }

        if(Items.getItem("castle_portal_2_completed") > 0)
        document.getElementById("castle-map-7-portal").style.display = "";

      }
      if(id == 8)
      {
        document.getElementById("castle-map-8-arrow-1").style.display = "";
        document.getElementById("castle-dead-dwarf").style.display = "";
        document.getElementById("castle-dead-combat-tutor").style.display = "";

        if(Items.getItem("sledge_hammer_picked_up"))
          document.getElementById("castle-dead-dwarf").src = "https://cdn.idle-pixel.com/images/dead_dwarf_hamerless.png";

        if(Items.getItem("giant_metal_ball_used") > 0) 
          document.getElementById("castle_hole").style.display = "";
        
        
      }
      if(id == 9)
      {
        document.getElementById("castle-map-9-arrow-1").style.display = "";
        document.getElementById("castle-map-9-arrow-2").style.display = "";
      }
      if(id == 10)
      {
        document.getElementById("castle-map-10-arrow-1").style.display = "";
        document.getElementById("castle-map-10-arrow-2").style.display = "";

        if(Items.getItem("castle_rock_awake") == 1) {
          document.getElementById("castle-rock-awake").style.display = "";
        }
        else {
          document.getElementById("castle-rock-statue").style.display = "";
        }

        if(Items.getItem("castle_golem_kills") > 0)
        {
          document.getElementById("castle-rock-awake").style.display = "none";
          document.getElementById("castle-rock-statue").style.display = "none";
          document.getElementById("castle-rock-statue-sad").style.display = "";
        }
        
        if(Items.getItem("castle_key_4_used") > 0)
          document.getElementById("castle-map-10-arrow-2").src = "https://cdn.idle-pixel.com/images/arrow_up.png";
        
      }

      if(id == 11)
      {
        document.getElementById("castle-map-11-arrow-1").style.display = "";
        document.getElementById("castle-bubble-skull-1").style.display = "";
      }
      
      if(id == 12)
      {
        document.getElementById("castle-map-12-portal").style.display = "";
        document.getElementById("castle-map-12-arrow").style.display = "";
      }

      if(id == 13)
      {
        document.getElementById("castle-map-13-arrow").style.display = "";
        document.getElementById("castle-map-13-arrow-2").style.display = "";
        document.getElementById("castle-13-quiz-arrow-up").style.display = "";
        document.getElementById("castle-13-quiz-arrow-down").style.display = "";
        document.getElementById("castle-13-quiz-arrow-left").style.display = "";
        document.getElementById("castle-13-quiz-arrow-right").style.display = "";

        if(Items.getItem('castle_chest_tablette') > 0 && Items.getItem("castle_chest_tablette_opened") == 0)
        {
          document.getElementById("castle-map-13-chest").style.display = "";
        }
      }

      if(id == 14)
      {
        document.getElementById("castle-map-14-arrow").style.display = "";
        document.getElementById("castle-map-14-arrow-2").style.display = "";
        document.getElementById("castle-map-14-arrow-3").style.display = "";
        document.getElementById("castle-saltwater-crocodile").style.display = "";
        document.getElementById("castle-map-14-hiddenarrow-1").style.display = "";

        if(Items.getItem("castle_key_5_used") > 0)
          document.getElementById("castle-map-14-arrow-2").src = "https://cdn.idle-pixel.com/images/arrow_up.png";
        if(Items.getItem("arrow_hidden_1") > 0)
          document.getElementById("castle-map-14-hiddenarrow-1").src = "https://cdn.idle-pixel.com/images/arrow_up.png";
          
        if(Items.getItem("castle_saltwater_crocodile_kills") > 0)
        {
          document.getElementById("castle-saltwater-crocodile").style.display = "none";
        }
        
      }

      if(id == 15)
      {
        document.getElementById("castle-map-15-arrow").style.display = "";
        document.getElementById("castle-map-15-arrow-2").style.display = "";
        document.getElementById("castle-yeti").style.display = "";

        if(Items.getItem("castle_yeti_kills") > 0)
        {
          document.getElementById("castle-yeti").style.display = "none";
        }
        
      }

      if(id == 16) 
      {
        document.getElementById("castle-map-16-chest").style.display = "";
        document.getElementById("castle-map-16-arrow").style.display = "";

        if(Items.getItem("hidden_castle_chest_1") > 0)
          document.getElementById("castle-map-16-chest").style.display = "none";
      }

      if(id == 17)
      {
        document.getElementById("castle-map-17-arrow").style.display = "";
        document.getElementById("castle-map-merchant").style.display = "";
      }

      if(id == 18)
      {
        document.getElementById("castle-map-18-arrow").style.display = "";
        document.getElementById("castle-map-18-arrow-2").style.display = "";
        document.getElementById("castle-bubble-3").style.display = ""; 
      }

      if(id == 19)
      {
        document.getElementById("castle-map-19-arrow").style.display = "";
        document.getElementById("castle-map-19-arrow-2").style.display = "";
      }

      if(id == 20)
      {
        document.getElementById("castle-map-20-arrow").style.display = "";
        document.getElementById("castle-map-20-arrow-1").style.display = "";
        document.getElementById("castle-map-20-arrow-2").style.display = "";
        document.getElementById("castle-map-20-arrow-3").style.display = "";
      }

      if(id >= 21 && id <= 25)
      {
        document.getElementById("castle-map-"+id+"-arrow").style.display = "";
        document.getElementById("castle-map-"+id+"-arrow-1").style.display = "";
        document.getElementById("castle-map-"+id+"-arrow-2").style.display = "";
        document.getElementById("castle-map-"+id+"-arrow-3").style.display = "";
      }

      if(id == 26)
      {
        document.getElementById("castle-map-26-arrow").style.display = "";
        document.getElementById("castle-map-26-arrow-1").style.display = "";
        document.getElementById("castle-map-26-arrow-2").style.display = "";
        document.getElementById("castle-map-26-arrow-3").style.display = "";
        document.getElementById("castle-map-26-arrow-4").style.display = "";
        document.getElementById("castle-map-26-arrow-5").style.display = "";
        document.getElementById("castle-map-26-arrow-6").style.display = "";
        document.getElementById("castle-map-26-arrow-7").style.display = "";
        document.getElementById("castle-map-26-arrow-8").style.display = "";
        document.getElementById("castle-map-26-arrow-9").style.display = "";
        document.getElementById("castle-map-26-arrow-10").style.display = "";

      }
      if(id == 27)
      {
        document.getElementById("castle-map-27-arrow").style.display = "";
        document.getElementById("castle-map-27-arrow-2").style.display = "";
      }
      if(id == 28)
      {
        document.getElementById("castle-map-28-arrow").style.display = "";
        document.getElementById("castle-map-28-arrow-1").style.display = "";
        
        document.getElementById("castle-map-28-dad_goblin").style.display = "";
        document.getElementById("castle-map-28-dad_goblin_notes").style.display = "";

        if(Items.getItem("castle_portal_3_completed") > 0)
        document.getElementById("castle-map-28-portal").style.display = "";
      }
      if(id == 29)
      {
        document.getElementById("castle-map-29-portal").style.display = "";
        document.getElementById("castle-map-29-arrow").style.display = "";
      }
      if(id == 30)
      {
        document.getElementById("castle-map-30-arrow-1").style.display = "";
        document.getElementById("castle-map-30-arrow-2").style.display = "";
        document.getElementById("castle-30-quiz-arrow-up").style.display = "";
        document.getElementById("castle-30-quiz-arrow-down").style.display = "";
        document.getElementById("castle-30-quiz-arrow-left").style.display = "";
        document.getElementById("castle-30-quiz-arrow-right").style.display = "";

        if(Items.getItem("castle_chest_tablette_2") > 0) {
          document.getElementById("castle-30-chest").style.display = "";
        }
        if(Items.getItem("castle_chest_tablette_2_opened") > 0) {
          document.getElementById("castle-30-chest").style.display = "none";
        }
        
      }

      if(id == 31) {
        document.getElementById("castle-map-31-arrow-1").style.display = "";
        document.getElementById("castle-map-31-arrow-2").style.display = "";
        document.getElementById("castle-map-31-arrow-3").style.display = "";
        document.getElementById("castle-map-31-monoculars").style.display = "";

      }

      if(id == 32) {
        document.getElementById("castle-map-32-arrow-1").style.display = "";
        document.getElementById("castle-map-32-train-dead").style.display = "";
        if(Items.getItem("looted_train_cond") > 0) {
          document.getElementById("castle-map-32-train-dead").src = "https://cdn.idle-pixel.com/images/dead_train_2.png"
        }
      }

      if(id == 33) {
        document.getElementById("castle-map-33-arrow-1").style.display = "";
        document.getElementById("castle-map-33-arrow-2").style.display = "";
        document.getElementById("castle-map-33-bubble-1").style.display = "";
        document.getElementById("castle-map-33-bubble-2").style.display = "";
        document.getElementById("castle-map-33-bubble-3").style.display = "";
        document.getElementById("castle-map-33-bubble-4").style.display = "";
        document.getElementById("castle-map-33-bubble-5").style.display = "";
      }

      
      if(id == 34) {
        document.getElementById("castle-map-34-arrow-1").style.display = "";
        document.getElementById("castle-map-34-arrow-2").style.display = "";
        document.getElementById("castle-map-34-bubble-1").style.display = "";
      }

      if(id == 35) {
        document.getElementById("castle-map-35-arrow-1").style.display = "";
        document.getElementById("castle-map-35-arrow-2").style.display = "";

        if(Items.getItem("castle_key_6_used") > 0) {
          document.getElementById("castle-map-35-arrow-2").src = "https://cdn.idle-pixel.com/images/arrow_up.png";
        }
      }

      if(id == 36) {
        document.getElementById("castle-map-36-arrow-1").style.display = "";
        document.getElementById("castle-map-36-faradox").style.display = "";

        if(Items.getItem("four_crystals_finished") > 0) {
          document.getElementById("castle-map-36-faradox").style.display = "none";
        }
      }
      
      if(id == 37) {
        document.getElementById("castle-map-37-arrow-1").style.display = "";
        document.getElementById("castle-map-37-bubble-1").style.display = "";
      }
  }
  static faradox_clicked(id) {

    if(Items.getItem("four_crystals_finished") > 0) return;

    if(Items.getItem('ice_crystal_final_touched') > 0) {
      Sounds.play("https://cdn.idle-pixel.com/sounds/deep_space.mp3")
      if(Items.getItem("forest_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-forest_crystal_final_touched").style.display = "";
      }
      if(Items.getItem("earth_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-earth_crystal_final_touched").style.display = "";
      }
      if(Items.getItem("fire_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-fire_crystal_final_touched").style.display = "";
      }
      if(Items.getItem("ice_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-ice_crystal_final_touched").style.display = "";
      }

      $("#body").fadeOut(20000)
      setTimeout(function()
        {
          websocket.send('FINISH_CASTLE')
          $("#body").fadeIn(1)
        }, 20000)

        document.getElementById("castle-map-36-faradox").onclick = function() {
          ""
        };
        return;
    }
    if(id == 0) {
      Modals.toggle('modal-faradox-clicked');
    }
    else if(id == 1) {
      if(Items.getItem("fight_points") < 12000) {
        Modals.open_image_modal('Faradox', 'images/x.png', 'You need 12,000 fight points to fight Faradox.', null, 'Close', null);
        return;
      }
      document.getElementById("castle-map-36-faradox").onclick = function() {
        Modals.open_image_modal('Faradox', 'images/x.png', 'You are too scared to approach faradox at this moment.', null, 'Close', null);
      };
      Sounds.play("https://cdn.idle-pixel.com/sounds/deep_space.mp3")
      if(Items.getItem("forest_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-forest_crystal_final_touched").style.display = "";
      }
      if(Items.getItem("earth_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-earth_crystal_final_touched").style.display = "";
      }
      if(Items.getItem("fire_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-fire_crystal_final_touched").style.display = "";
      }
      if(Items.getItem("ice_crystal_final_touched") > 0) {
        document.getElementById("castle-map-36-ice_crystal_final_touched").style.display = "";
      }

      $("#body").fadeOut(20000)
      setTimeout(function()
        {
          websocket.send('FIGHT_FARADOX')
          $("#body").fadeIn(1)
        }, 20000)
      

    }
  }

  static look_portrait(id) {
    if(id == 1) {
      document.getElementById("modal-large-image-src").src = "https://cdn.idle-pixel.com/images/guardian_one_portrait.png"
      Modals.toggle('modal-large-image')
    }
    if(id == 2) {
      document.getElementById("modal-large-image-src").src = "https://cdn.idle-pixel.com/images/guardian_two_portrait.png"
      Modals.toggle('modal-large-image')
    }
    if(id == 3) {
      document.getElementById("modal-large-image-src").src = "https://cdn.idle-pixel.com/images/guardian_three_portrait.png"
      Modals.toggle('modal-large-image')
    }
    if(id == 4) {
      document.getElementById("modal-large-image-src").src = "https://cdn.idle-pixel.com/images/guardian_four_portrait.png"
      Modals.toggle('modal-large-image')
    }
    if(id == 5) {
      document.getElementById("modal-large-image-src").src = "https://cdn.idle-pixel.com/images/faradox_portrait.png"
      Modals.toggle('modal-large-image')
    }
  }

  static fight_monster(monster)
  {
    if(monster == "castle_golem")
      Modals.open_image_modal('CASTLE MONSTER', 'images/'+monster+'_icon.png', 'Fight this monster?<br /><br /><span class="color-grey">Maybe I can use my own bomb.</span>', 'Fight!', 'Close', 'CASTLE_FIGHT=' + monster);
    else
      Modals.open_image_modal('CASTLE MONSTER', 'images/'+monster+'_icon.png', 'Fight this monster?', 'Fight!', 'Close', 'CASTLE_FIGHT=' + monster);
  }

  static clicks_castle_rock_sad()
  {
    Modals.open_image_modal('CASTLE MONSTER', 'images/castle_rock_sad.png', 'I was only following Faradox\'s commands, by force :(.', null, 'Close', null);
  }

  static clicksMerchant()
  {

    var testingFor = "";
    
    testingFor = "pine_logs"
    if(Items.getItem("castle_"+testingFor+"_bought") > 0)
    {
      document.getElementById("modal-castle-shop-" + testingFor).innerHTML = "Purchased <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' />";
      document.getElementById("modal-castle-shop-" + testingFor).backgroundColor = "grey";
      document.getElementById("modal-castle-shop-" + testingFor).disabled = true;
    }

    testingFor = "pine_tree_seeds"
    if(Items.getItem("castle_"+testingFor+"_bought") > 0)
    {
      document.getElementById("modal-castle-shop-" + testingFor).innerHTML = "Purchased <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' />";
      document.getElementById("modal-castle-shop-" + testingFor).backgroundColor = "grey";
      document.getElementById("modal-castle-shop-" + testingFor).disabled = true;
    }

    testingFor = "dragon_bar"
    if(Items.getItem("castle_"+testingFor+"_bought") > 0)
    {
      document.getElementById("modal-castle-shop-" + testingFor).innerHTML = "Purchased <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' />";
      document.getElementById("modal-castle-shop-" + testingFor).backgroundColor = "grey";
      document.getElementById("modal-castle-shop-" + testingFor).disabled = true;
    }

    testingFor = "scythe_pieces"
    if(Items.getItem("castle_"+testingFor+"_bought") > 0)
    {
      document.getElementById("modal-castle-shop-" + testingFor).innerHTML = "Purchased <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' />";
      document.getElementById("modal-castle-shop-" + testingFor).backgroundColor = "grey";
      document.getElementById("modal-castle-shop-" + testingFor).disabled = true;
    }

    testingFor = "red_treasure_chest"
    if(Items.getItem("castle_"+testingFor+"_bought") > 0)
    {
      document.getElementById("modal-castle-shop-" + testingFor).innerHTML = "Purchased <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' />";
      document.getElementById("modal-castle-shop-" + testingFor).backgroundColor = "grey";
      document.getElementById("modal-castle-shop-" + testingFor).disabled = true;
    }

    testingFor = "castle_boots"
    if(Items.getItem("castle_"+testingFor+"_bought") > 0)
    {
      document.getElementById("modal-castle-shop-" + testingFor).innerHTML = "Purchased <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' />";
      document.getElementById("modal-castle-shop-" + testingFor).backgroundColor = "grey";
      document.getElementById("modal-castle-shop-" + testingFor).disabled = true;
    }

    testingFor = "castle_portal_3"
    if(Items.getItem("castle_"+testingFor+"_bought") > 0)
    {
      document.getElementById("modal-castle-shop-" + testingFor).innerHTML = "Purchased <img src='https://cdn.idle-pixel.com/images/check.png' class='w15' />";
      document.getElementById("modal-castle-shop-" + testingFor).backgroundColor = "grey";
      document.getElementById("modal-castle-shop-" + testingFor).disabled = true;
    }

    if(Items.getItem("can_buy_castle_portal_3") > 0)
    {
      document.getElementById("modal-castle-shop-castle_portal_3").style.display = "";
    }

    document.getElementById("modal-castle-shop-current-tainted-coins").innerHTML = format_number(Items.getItem('tainted_coins'));
    Modals.toggle("modal-castle-shop");
  }

  static clicks_dead_dwarf()
  {
    if(Items.getItem("sledge_hammer_picked_up"))
    {
      Modals.open_image_modal('DEAD COMBAT TUTOR', 'images/dead_dwarf_hamerless.png', 'Doric who has been killed by Faradox.', null, 'Close', null);
    }
    else
      Modals.open_image_modal('DEAD DWARF', 'images/dead_dwarf.png', 'A dead dwarf killed by Faradox.<br /><br />Take his sledge hammer?', 'Take Sledge Hammer', 'Close', 'CASTLE_PICKUP_ITEM=sledge_hammer');
  }

  static clicks_dead_combat_tutor()
  {
    Modals.open_image_modal('DEAD COMBAT TUTOR', 'images/dead_combat_tutor.png', 'A dead combat instructor killed by Faradox.', null, 'Close', null);
    websocket.send('SOLVE_RED_MAP_11')
  }
  

  static faradox_entry_message()
  {
    Modals.open_image_modal('CASTLE MESSAGE', 'images/thief_leader_note.png', 'Do not continue into the castle dungeon unless you have authority from Faradox.', null, 'Close', null)
  }

  static quiz_color_balls_message()
  {
    Modals.open_image_modal('CASTLE MESSAGE', 'images/rgb.png', 'Quiz Door Hint', null, 'Close', null)
  }

  static clicks_dad_goblin()
  {
    Modals.open_image_modal('DAD GOBLIN', 'images/dad_goblin.png', 'Thank you for cutting children toenails.<br /><br />I cannot give you castle secrets, Faradox said no for this.', null, 'Close', null)
  }

  static clicks_dad_goblin_stairs()
  {
    Modals.open_image_modal('DAD GOBLIN', 'images/dad_goblin.png', 'No human, you cannot go there.', null, 'Close', null)
  }


  

  static clicks_dad_goblin_notes()
  {
    Modals.open_image_modal('DAD GOBLIN NOTES', 'images/thief_leader_note.png', '\"The merchant from the castle will sell portals to the next floor if I buy a dreid shroom followed by a dusty hammer.\"<br /><br /><i class="color-grey">It seems like the dad goblin is writing down castle secrets to not forget them.</i>', null, 'Close', null)
  }

  static quiz_ice_path_bubble()
  {
    Modals.open_image_modal('CASTLE MESSAGE', 'images/thief_leader_note.png', 'Strange things happening ahead.  Proceed with caution.', null, 'Close', null)
  }

  static switch_maps(id)
  {
    if(id == 2 && Items.getItem('castle_key_1_picked_up') == 0)
    {
      $("#faradox-huge-image").fadeIn(3000, function() { $("#faradox-huge-image").fadeOut(1000)});
    }
    websocket.send('CASTLE_NAVIGATE=' + id);
  }

  static clicks_castle_rock()
  {
    var mapId = Items.getItem("castle_map");
    if(mapId != 10)
      return;

    if(Items.getItem('sledge_hammer') > 0)
    {
      document.getElementById("modal-castle-rock-sledge_hammer").style.display = "";
    }
    Modals.toggle('modal-castle-rock');

  }

  static pickup_item(item)
  {
    websocket.send('CASTLE_PICKUP_ITEM='+item);
  }

  static clicks_pressure_plate(id)
  {
    if(id == 1)
    {
      if(Items.getItem("heavy_rock"))
      {
        websocket.send('CASTLE_MISC=pressure_plate_1');
        return;
      }
      Modals.open_image_modal('Pressure Plate', 'images/x.png', 'You need a heavy rock found within the castle to activate pressure plates.', null, 'Close', null);
    }
  }

  static clicks_wizard()
  {
    websocket.send('CASTLE_MISC=clicks_wizard_1');
  }
  static open_quiz(value)
  {
    switch(value){
      case "castle_quiz_1":
      {
        if(Items.getItem('green_ball') == 0 || Items.getItem('red_ball') == 0 || Items.getItem('blue_ball') == 0)
        {
          Modals.open_image_modal('QUIZ DOOR', 'images/x.png', 'You do not have the required items to open the quiz door.', null, 'Close', null);
          return;
        }
        
        Modals.toggle("modal-quiz-door-6-1");
      }
        
      break;
    }
  }

  static toggle_ball_color(id)
  {
    var img_element = document.getElementById("modal-quiz-door-6-1-img-" + id);
    if(("" + img_element.src).endsWith("black_ball.png"))
    {
      img_element.src = "https://cdn.idle-pixel.com/images/red_ball.png"
    }
    else if(("" + img_element.src).endsWith("red_ball.png"))
    {
      img_element.src = "https://cdn.idle-pixel.com/images/green_ball.png"
    }
    else if(("" + img_element.src).endsWith("green_ball.png"))
    {
      img_element.src = "https://cdn.idle-pixel.com/images/blue_ball.png"
    }
    else if(("" + img_element.src).endsWith("blue_ball.png"))
    {
      img_element.src = "https://cdn.idle-pixel.com/images/red_ball.png"
    }

  }

  static guardian_3_statue()
  {
    websocket.send('CASTLE_MISC=guardian_3_tombstone');
  }

  static solve_quiz_ball_colors()
  {
    var color_1_good = ("" + document.getElementById("modal-quiz-door-6-1-img-" + 1).src).endsWith("red_ball.png");
    var color_2_good = ("" + document.getElementById("modal-quiz-door-6-1-img-" + 2).src).endsWith("green_ball.png");
    var color_3_good = ("" + document.getElementById("modal-quiz-door-6-1-img-" + 3).src).endsWith("blue_ball.png");

    if(color_1_good && color_2_good && color_3_good)
    {
      websocket.send('SOLVE_CASTLE_QUIZ=rgb');
    }
    else
    {
      Modals.open_image_modal('QUIZ DOOR', 'images/x.png', 'Incorrect.', null, 'Close', null);
    }
  }

  static castle_rock_slege_hammer_counter = 0;
  static castle_rock_tool(tool) 
  {
    if(tool == 'sledge_hammer')
    {
      if(Castle.castle_rock_slege_hammer_counter == 0)
      {
        Modals.open_image_modal('CASTLE ROCK', 'images/castle_rock.png', 'Grrr.', null, 'Close', null);
        Castle.castle_rock_slege_hammer_counter++;
        return;
      }
      if(Castle.castle_rock_slege_hammer_counter == 1)
      {
        Modals.open_image_modal('CASTLE ROCK', 'images/castle_rock.png', 'WHO DARE WAKES ME!', null, 'Close', null);
        Castle.castle_rock_slege_hammer_counter++;
        return;
      }
      if(Castle.castle_rock_slege_hammer_counter == 2)
      {
        websocket.send('CASTLE_MISC=castle_rock_awake');
        Modals.toggle('modal-castle-rock');
        return;
      }
      return;
    }
    Modals.open_image_modal('CASTLE ROCK', 'images/x.png', 'The rock does not react.', null, 'Close', null);
  }
}