class DonorShop
{
    static refresh_active_labels()
    {
        DonorShop.refresh_active_label("donor-farming-active-label", Items.getItem("donor_farm_patches_timestamp"));
        DonorShop.refresh_active_label("donor-woodcutting-active-label", Items.getItem("donor_tree_patches_timestamp"));
        DonorShop.refresh_active_label("donor-offline-time-active-label", Items.getItem("donor_offline_timer_timestamp"));
        DonorShop.refresh_active_label("donor-potion-stacker-active-label", Items.getItem("donor_potion_stacker_timestamp"));
        DonorShop.refresh_active_label("donor-bonus-xp-active-label", Items.getItem("donor_bonus_xp_timestamp"));
    }

    static refresh_active_label(id, donor_timestamp)
    {
        var diff = donor_timestamp - get_current_millis();

        if(donor_timestamp == 0 || diff <= 0)
        {
            document.getElementById(id).style.color = "pink";
            document.getElementById(id).innerHTML = "NOT ACTIVE";
        }
        else
        {
            var days = diff / 1000 / 60 / 60 / 24;
            days = parseInt(days) + 1;
            document.getElementById(id).style.color = "lime";
            document.getElementById(id).innerHTML = days + " days";
        }
        
    }
    
    static has_donor_active(donor_timestamp)
    {
        if(donor_timestamp == 0)
            return false;
    
        var diff = donor_timestamp - get_current_millis();

        if(diff < 0)
            return false;

        return true;
    }
}