class OddOneOutPuzzle
{

  static balance_used_count = 0;
  static left_side = ['none', 'none', 'none']
  static right_side = ['none', 'none', 'none']

  static reset(balance_used_count) {

    this.balance_used_count = parseInt(balance_used_count);
    this.left_side = ['none', 'none', 'none']
    this.right_side = ['none', 'none', 'none']

    document.getElementById("modal-odd-one-out-puzzle-balance-img").src = "https://cdn.idle-pixel.com/images/odd_one_out_empty.png";
    
    document.getElementById("modal-odd-one-out-puzzle-weight-img-1").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-2").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-3").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-4").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-5").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-6").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-7").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-8").style.visibility = ''
    document.getElementById("modal-odd-one-out-puzzle-weight-img-9").style.visibility = ''

    document.getElementById("modal-odd-one-out-puzzle-weight-img-1-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-2-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-3-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-4-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-5-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-6-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-7-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-8-left").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-9-left").style.display = 'none'

    document.getElementById("modal-odd-one-out-puzzle-weight-img-1-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-2-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-3-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-4-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-5-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-6-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-7-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-8-right").style.display = 'none'
    document.getElementById("modal-odd-one-out-puzzle-weight-img-9-right").style.display = 'none'

    document.getElementById("modal-odd-one-out-puzzle-balance-uses").innerHTML = "("+this.balance_used_count+"/2)"

    if(this.balance_used_count >= 2) {
      Modals.toggle("modal-odd-one-out-puzzle");
      Modals.toggle("modal-odd-one-out-puzzle-select");
    }
  }

  static submit_weight(index) {
    websocket.send('ODD_ONE_OUT_PUZZLE_SELECT_WEIGHT=' + index)
  }

  static refresh() {
    if(this.left_side[0] != 'none') {
      var val = this.left_side[0];
      document.getElementById("modal-odd-one-out-puzzle-weight-img-"+val+"-left").style.display = ''
      document.getElementById("modal-odd-one-out-puzzle-weight-img-" + val).style.visibility = 'hidden';
    }
    if(this.left_side[1] != 'none') {
      var val = this.left_side[1];
      document.getElementById("modal-odd-one-out-puzzle-weight-img-"+val+"-left").style.display = ''
      document.getElementById("modal-odd-one-out-puzzle-weight-img-" + val).style.visibility = 'hidden';
    }
    if(this.left_side[2] != 'none') {
      var val = this.left_side[2];
      document.getElementById("modal-odd-one-out-puzzle-weight-img-"+val+"-left").style.display = ''
      document.getElementById("modal-odd-one-out-puzzle-weight-img-" + val).style.visibility = 'hidden';
    }

    if(this.right_side[0] != 'none') {
      var val = this.right_side[0];
      document.getElementById("modal-odd-one-out-puzzle-weight-img-"+val+"-right").style.display = ''
      document.getElementById("modal-odd-one-out-puzzle-weight-img-" + val).style.visibility = 'hidden';
    }
    if(this.right_side[1] != 'none') {
      var val = this.right_side[1];
      document.getElementById("modal-odd-one-out-puzzle-weight-img-"+val+"-right").style.display = ''
      document.getElementById("modal-odd-one-out-puzzle-weight-img-" + val).style.visibility = 'hidden';
    }
    if(this.right_side[2] != 'none') {
      var val = this.right_side[2];
      document.getElementById("modal-odd-one-out-puzzle-weight-img-"+val+"-right").style.display = ''
      document.getElementById("modal-odd-one-out-puzzle-weight-img-" + val).style.visibility = 'hidden';
    }
  }

  static clicks_weight_from_top(index) {
    if(this.left_side[0] == 'none') {
      this.left_side[0] = index;
    }
    else if(this.left_side[1] == 'none') {
      this.left_side[1] = index;
    }
    else if(this.left_side[2] == 'none') {
      this.left_side[2] = index;
    }
    else if(this.right_side[0] == 'none') {
      this.right_side[0] = index;
    }
    else if(this.right_side[1] == 'none') {
      this.right_side[1] = index;
    }
    else if(this.right_side[2] == 'none') {
      this.right_side[2] = index;
    }
    this.refresh();
  }

  static activate_balance() {

   
    if(this.left_side[0] == "none" ||
       this.left_side[1] == "none" ||
       this.left_side[2] == "none" ||
       this.right_side[0] == "none" ||
       this.right_side[1] == "none" ||
       this.right_side[2] == "none"
    )
    {
      Modals.open_image_modal("ERROR", "images/x.png", "You need 3 weights on each side to activate the balance.", null, "Close", null, null);
      return;
    }

    var answer = Items.getItem('odd_one_out_weight') / 1565;
    if(this.left_side[0] == answer || this.left_side[1] == answer || this.left_side[2] == answer) {
      document.getElementById("modal-odd-one-out-puzzle-balance-img").src = "https://cdn.idle-pixel.com/images/odd_one_out_left.png";
      setTimeout(function() {
        OddOneOutPuzzle.reset(OddOneOutPuzzle.balance_used_count + 1);
        document.getElementById("modal-odd-one-out-puzzle-balance-img").src = "https://cdn.idle-pixel.com/images/odd_one_out_empty.png";
      }, 2000);
    } else if(this.right_side[0] == answer || this.right_side[1] == answer || this.right_side[2] == answer) {
      document.getElementById("modal-odd-one-out-puzzle-balance-img").src = "https://cdn.idle-pixel.com/images/odd_one_out_right.png";
      setTimeout(function() {
        OddOneOutPuzzle.reset(OddOneOutPuzzle.balance_used_count + 1);
        document.getElementById("modal-odd-one-out-puzzle-balance-img").src = "https://cdn.idle-pixel.com/images/odd_one_out_empty.png";
      }, 2000);
    } else {
      document.getElementById("modal-odd-one-out-puzzle-balance-img").src = "https://cdn.idle-pixel.com/images/odd_one_out_equal.png";
        setTimeout(function() {
          OddOneOutPuzzle.reset(OddOneOutPuzzle.balance_used_count + 1);
          document.getElementById("modal-odd-one-out-puzzle-balance-img").src = "https://cdn.idle-pixel.com/images/odd_one_out_empty.png";
        }, 2000);
    }

    
  }
}