class ScrollSockets
{
    static refresh_tab()
    {
        if(Ores.getPickaxeToolData()[0] == "none")
            document.getElementById("socket-tools-pickaxe-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
        else
            document.getElementById("socket-tools-pickaxe-desc").innerHTML = "Each upgrade reduces the amount of stardust required when converting bars into XP.";

       if(Crafting.getHammerToolData()[0] == "none")
            document.getElementById("socket-tools-hammer-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-hammer-desc").innerHTML = "Each upgrade reduces the amount of stardust required when converting bars into XP.";

        if(Farming.getRakeToolData()[0] == "none")
            document.getElementById("socket-tools-rake-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
        else
            document.getElementById("socket-tools-rake-desc").innerHTML = "Each upgrade increases your chance at finding seeds by 5%.";

        if(Woodcutting.getAxeToolData()[0] == "none")
            document.getElementById("socket-tools-axe-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
        else
            document.getElementById("socket-tools-axe-desc").innerHTML = "	Each upgrade increases your logs by +5 for every tree.";


        if(Fishing.getFishingNetToolData("fishing_net")[0] == "none")
            document.getElementById("socket-tools-fishing_net-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-fishing_net-desc").innerHTML = "Each upgrade increases your fishing xp when catching fish by 5%.";

        if(Fishing.getFishingNetToolData("fishing_rod")[0] == "none")
            document.getElementById("socket-tools-fishing_rod-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-fishing_rod-desc").innerHTML = "Each upgrade increases your fishing xp when catching fish by 5%.";

        if(Fishing.getFishingNetToolData("harpoon")[0] == "none")
            document.getElementById("socket-tools-harpoon-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-harpoon-desc").innerHTML = "Each upgrade increases your fishing xp when catching fish by 5%.";

            if(Needle.getNeedleToolData()[0] == "none")
            document.getElementById("socket-tools-needle-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-needle-desc").innerHTML = "Each upgrade allows you to undo higher level armour.";

        if(Brewing.getBrewingKitToolData()[0] == "none")
            document.getElementById("socket-tools-brewing_kit-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-brewing_kit-desc").innerHTML = "Each upgrade increases your potion time by 25%.";
        
        if(Ores.getChiselToolData()[0] == "none")
            document.getElementById("socket-tools-chisel-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-chisel-desc").innerHTML = "Each upgrade allows you to find the next tier of geodes.";

        if(Farming.getWateringCanToolData()[0] == "none")
            document.getElementById("socket-tools-watering_can-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
       else
            document.getElementById("socket-tools-watering_can-desc").innerHTML = "Each upgrade will water an additional farming patch when activated.";

            if(Invention.getToolkitToolData()[0] == "none")
            document.getElementById("socket-tools-toolkit-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
        else
            document.getElementById("socket-tools-toolkit-desc").innerHTML = "Each upgrade allows you to break down higher level weapons / amulets.";

        if(Invention.getMagnetToolData()[0] == "none")
            document.getElementById("socket-tools-magnet-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
        else
            document.getElementById("socket-tools-magnet-desc").innerHTML = "Each upgrade increases the rate at which you find items from gathering junk.";

        if(Woodcutting.getMacheteToolData()[0] == "none")
            document.getElementById("socket-tools-machete-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
        else
            document.getElementById("socket-tools-machete-desc").innerHTML = "Each upgrade increases the chance of getting double fruits from fruit trees.";

        if(Farming.getTrowelToolData()[0] == "none")
            document.getElementById("socket-tools-trowel-desc").innerHTML = "<span class='color-red'>You don't have this tool yet.</span>";
        else
            document.getElementById("socket-tools-trowel-desc").innerHTML = "Each upgrade increases your chance at finding vegetable seeds by 5%.";
    }

    // returns [counter, total]
    static getSocketScrollStats() {
        var counter = 0;
        var total = 0;
        var testingFor = "";

        testingFor = "pickaxe";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "hammer";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "rake";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "axe";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "fishing_net";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "fishing_rod";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "harpoon";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "needle";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "brewing_kit";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "chisel";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "watering_can";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        testingFor = "toolkit";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;
        
        testingFor = "magnet";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;
       
        testingFor = "machete";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;
        
        testingFor = "trowel";
        total += 5;
        if(Items.getItem("diamond_" + testingFor)) counter += 5;
        else if(Items.getItem("ruby_" + testingFor)) counter += 4;
        else if(Items.getItem("emerald_" + testingFor)) counter += 3;
        else if(Items.getItem("sapphire_" + testingFor)) counter += 2;
        else if(Items.getItem(testingFor)) counter += 1;

        return [parseInt(counter), parseInt(total)];
    }

    static refreshSocketScrollLabelsTab() {

        var data = ScrollSockets.getSocketScrollStats();
        var counter = data[0];
        var total = data[1];

        if(counter == total)
            document.getElementById("title-socket_scroll").innerHTML = "<span class='color-green'>" + (counter + "") + "/" +  (total + "");
        else
            document.getElementById("title-socket_scroll").innerHTML = "<span class='color-gold'>" + (counter + "") + "/" +  (total + "");
    }

    static refreshSocketScrollLabels() {

        var data = ScrollSockets.getSocketScrollStats();
        var counter = data[0];
        var total = data[1];

        if(counter == total)
            document.getElementById("itembox-label-socket_scroll").innerHTML = "<span class='color-lime'>" + (counter + "") + "/" +  (total + "");
        else
            document.getElementById("itembox-label-socket_scroll").innerHTML = "<span class='color-yellow'>" + (counter + "") + "/" +  (total + "");
    }
}

