
class Sounds
{
    static audio;

    static VARIABLE_MENU = "https://cdn.idle-pixel.com/sounds/menu1.wav";
    static VARIABLE_PLANT = "https://cdn.idle-pixel.com/sounds/plant.ogg";
    static VARIABLE_FARADOX = "https://cdn.idle-pixel.com/sounds/scary.mp3";
    static VARIABLE_POWER_UP = "https://cdn.idle-pixel.com/sounds/powerup.mp3";
    static VARIABLE_QUEST_COMPLETED = "https://cdn.idle-pixel.com/sounds/quest_completed.mp3";
    static VARIABLE_CRAFT = "https://cdn.idle-pixel.com/sounds/craft.wav";
    static VARIABLE_HERO_DEATH = "https://cdn.idle-pixel.com/sounds/hero_death.mp3";
    static VARIABLE_LEVEL = "https://cdn.idle-pixel.com/sounds/level.wav";
    static VARIABLE_ACH_PERK = "https://cdn.idle-pixel.com/sounds/ach.wav";
    static VARIABLE_BOMB = "https://cdn.idle-pixel.com/sounds/bomb.mp3";
    static VARIABLE_LEVEL_100 = "https://cdn.idle-pixel.com/sounds/100.mp3";
    static VARIABLE_EARTHQUAKE = "https://cdn.idle-pixel.com/sounds/earchquake.mp3";
    static VARIABLE_CRITICAL = "https://cdn.idle-pixel.com/sounds/critical.wav";
    static VARIABLE_BLOODIFY = "https://cdn.idle-pixel.com/sounds/bloodify.mp3";
    static VARIABLE_FARDOX_CASTLE = "https://cdn.idle-pixel.com/sounds/faradox_castle.mp3";
    static VARIABLE_SPLASH_SPECIAL = "https://cdn.idle-pixel.com/sounds/interface-open-special.mp3";
    static VARIABLE_CASTLE_KEY_GET = "https://cdn.idle-pixel.com/sounds/castle_key_get.mp3";
    static VARIABLE_TROPHY = "https://cdn.idle-pixel.com/sounds/trophy.mp3";
    static VARIABLE_SELL_ITEM = "https://cdn.idle-pixel.com/sounds/sell.wav";

    

    static _sounds = [];
    static play(path)
    {
        if(Items.getItem("settings_sound") == 4)
            return;

        if(Sounds._sounds[path] === undefined)
        {
            Sounds._sounds[path] = new Audio(path);
        }

        Sounds.audio = Sounds._sounds[path];
        if(Items.getItem("settings_sound") == 0) Sounds.audio.volume = 0.75;
        if(Items.getItem("settings_sound") == 1) Sounds.audio.volume = 0.5;
        if(Items.getItem("settings_sound") == 2) Sounds.audio.volume = 0.25;
        if(Items.getItem("settings_sound") == 3) Sounds.audio.volume = 0.10;

        if(path != "https://cdn.idle-pixel.com/sounds/scroll_text.mp3")
        Sounds.audio.currentTime = 0
        Sounds.audio.play();
    }

    static playNotifSoundExample() {
        if(Items.getItem("settings_sound") == 4) {
            Modals.open_error_dialogue("You need to have sound turned on to use this.")
            return;
        }
        Sounds.play('https://cdn.idle-pixel.com/sounds/notif.mp3')
    }
    static togglePlaySoundWhenCompleted(slug) {
        if(Items.getItem("settings_sound") == 4) {
            Modals.open_error_dialogue("You need to have sound turned on to use this.")
            return false;
        }
        websocket.send('SETTINGS=sound_notif_' + slug);
    }

    
}