function get_level(playerXP, includeVirtual)
{
    if(playerXP == 0)
        return 1;
    
    var iMax = 100;
    if(includeVirtual)
        iMax = 1000;
    
    for(var i = 1; i <= iMax; i++)
    {
        var power = 3 + (i / 200);
        var xp = Math.pow(i, power);
        if(playerXP < xp)
            return i - 1;
    }
    
    return iMax;
}


function get_xp_required(level)
{
    return parseInt(Math.pow(level, 3 + (level / 200)));
}

function refresh_xp_required_labels()
{
    var skill = "";
    var current_xp = 0;
    var current_level = 0;
    var xp_required = 0;


    skill = "mining";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "crafting";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "gathering";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "farming";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "brewing";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "woodcutting";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "cooking";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "fishing";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "breeding";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "invention";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "melee";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "archery";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";

    skill = "magic";
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    if(current_level >= 100) hide_element("next-level-"+skill+"-xp-required")
    document.getElementById("next-level-"+skill+"-xp-required").innerHTML = format_number(xp_required - current_xp) + " xp until next level";
}

function get_global_xp() {
    var i = 0;
    i += Items.getItem("mining_xp");
    i += Items.getItem("crafting_xp");
    i += Items.getItem("gathering_xp");
    i += Items.getItem("farming_xp");
    i += Items.getItem("brewing_xp");
    i += Items.getItem("woodcutting_xp");
    i += Items.getItem("cooking_xp");
    i += Items.getItem("fishing_xp");
    i += Items.getItem("invention_xp");
    i += Items.getItem("melee_xp");
    i += Items.getItem("magic_xp");
    i += Items.getItem("archery_xp");
    return i;
}
function show_xp_gained_left_menu_bar(skill, xp) {



    if(!Globals.tabActive) return;
    document.getElementById("menu-bar-"+skill+"-xp").innerHTML = "&nbsp;&nbsp;&nbsp;+" + format_number(xp) + " xp";
    $("#menu-bar-"+skill+"-xp").fadeIn()
    setTimeout(function() {
        $("#menu-bar-"+skill+"-xp").fadeOut()
    }, 1000)
}

function refresh_xp_bar(skill)
{
    
    current_xp = Items.getItem(skill + "_xp");
    current_level = get_level(current_xp);
    xp_required = get_xp_required(current_level + 1);
    xp_required_previous_level = get_xp_required(current_level);

    var percentage_width = (xp_required - current_xp) / (xp_required - xp_required_previous_level) * 100;
    var width = 100 - percentage_width + "%";
   
    var color = null;
    if(current_level >= 100) {
        width = "100%";
    }
    $('#progress-bar-' + skill).animate({
        width:width
    },
    2000,
    "linear");

    $('#left-menu-progress-bar-' + skill).animate({
        width:width
    },
    2000,
    "linear");

    if(color != null) {
        document.getElementById("left-menu-progress-bar-" + skill).style.backgroundColor = color;
    }
}
function refresh_skill_levels_menu_bar(skill)
{
    var level = get_level(Items.getItem(skill + "_xp"));
 
    if(level >= 100)
        document.getElementById("menu-bar-"+skill+"-level").innerHTML = "<span style='color:cyan'>Level 100</span>";
    else
        document.getElementById("menu-bar-"+skill+"-level").innerHTML = "Level "+level+"";
}

function unlock_skill(skill)
{

    if(document.getElementById("menu-bar-"+skill+"-table-btn-wrapper") != null) {
        document.getElementById("menu-bar-"+skill+"-table-btn-wrapper").style.display = '';
    }

    if(skill != "invention")
    hide_element("menu-bar-"+skill+"-lock-icon");
    if(document.getElementById("menu-bar-"+skill+"-level") != null) {
        document.getElementById("menu-bar-"+skill+"-level").style.color = "";
    }
    
    
    
    
    //document.getElementById("menu-bar-"+skill+"-icon-2").src = get_image("images/"+skill+".png");
    refresh_skill_levels_menu_bar(skill)

}