class Animations
{
    static unlock_stardust()
    {
        var stardust_element = document.getElementById("menu-bar-stardust");
        var stardust_element_img = document.getElementById("menu-bar-stardust-img");
        stardust_element_img.style.width="300px";
        stardust_element.style.display = "";
        stardust_element_img.classList.add("animation-glow");

        $(stardust_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            stardust_element_img.classList.remove("animation-glow"); 
            websocket.send("STARDUST_UNLOCKED");
        });
    }

    static unlock_mining()
    {
        var stardust_element = document.getElementById("left-panel-item_panel-mining");
        var stardust_element_img = document.getElementById("menu-bar-mining-icon");
        stardust_element_img.style.width="300px";
        stardust_element.style.display = "";
        stardust_element_img.classList.add("animation-glow");

        $(stardust_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            stardust_element_img.classList.remove("animation-glow"); 
        });
    }

    static unlock_melee()
    {
        // var stardust_element = document.getElementById("left-panel-item_panel-combat-melee");
        // var stardust_element_img = document.getElementById("menu-bar-melee-icon");
        // stardust_element_img.style.width="300px";
        // stardust_element.style.display = "";
        // stardust_element_img.classList.add("animation-glow");

        // $(stardust_element_img).animate({
        //     "width": 20,
        //     "height": 20,
        // }, 5000, function() { 
        //     stardust_element_img.classList.remove("animation-glow"); 
        //     Modals.open_image_modal('Skills', 'images/thief_leader.png', 'You may now fight enemies, this is just the beginning.  Do not visit the forest.', null, 'Close', null)
        // });
    }

    static unlock_archery()
    {
        // var stardust_element = document.getElementById("left-panel-item_panel-combat-archery");
        // var stardust_element_img = document.getElementById("menu-bar-archery-icon");
        // stardust_element_img.style.width="300px";
        // stardust_element.style.display = "";
        // stardust_element_img.classList.add("animation-glow");

        // $(stardust_element_img).animate({
        //     "width": 20,
        //     "height": 20,
        // }, 5000, function() { 
        //     stardust_element_img.classList.remove("animation-glow"); 
        //     Modals.open_image_modal('Skills', 'images/reaper_icon.png', 'You may now fight enemies, this is just the beginning.  Do not visit the haunted mansion.', null, 'Close', null)
        // });
    }

    static unlock_magic()
    {
        // var stardust_element = document.getElementById("left-panel-item_panel-combat-magic");
        // var stardust_element_img = document.getElementById("menu-bar-magic-icon");
        // stardust_element_img.style.width="300px";
        // stardust_element.style.display = "";
        // stardust_element_img.classList.add("animation-glow");

        // $(stardust_element_img).animate({
        //     "width": 20,
        //     "height": 20,
        // }, 5000, function() { 
        //     stardust_element_img.classList.remove("animation-glow"); 
        //     Modals.open_image_modal('Skills', 'images/fire_witch_wiki.png', 'You may now fight enemies, this is just the beginning.  Do not visit the volcano.', null, 'Close', null)
        // });
    }

    static unlock_faradox_castle()
    {
        Sounds.play(Sounds.VARIABLE_EARTHQUAKE);
        document.getElementById('body').classList.add('shake');
        setTimeout(function() {
            document.getElementById('body').classList.remove('shake');
        }, 6000);
        $('#content').animate({opacity:0}, 8000, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");
        });
        $('#cutscenes-7-castle').delay(10000).fadeIn(function()
        {
            Modals.open_faradox_castle();
            Sounds.play(Sounds.VARIABLE_FARDOX_CASTLE);
            setTimeout(function() {
                Modals.toggle('modal-faradox-castle');
                $('#cutscenes-7-castle').delay(5000).fadeOut();
                $('#cutscenes-7').delay(5000).fadeIn();
            }, 6000);

        });
    }
    
    static unlock_faradox_castle_text()
    {
        document.getElementById('cutscenes-7-next-btn').disabled = true;
        var step = document.getElementById("cutscenes-7-image-hidden").value;
        var textElement = document.getElementById("cutscenes-7-text");
        var imgElement = document.getElementById("cutscenes-7-image");
        
        setTimeout(function() {
            document.getElementById('cutscenes-7-next-btn').disabled = false;
        }, 1000);
    
        switch(parseInt(step))
        {
            case 1:
                textElement.innerHTML = '"How is this happening."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 2:
                textElement.innerHTML = '"Sorry master.  The hero has slain me,"'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox_gaurdian_1_white.png"
            break;
            case 3:
                textElement.innerHTML = '"This is not good."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 4:
                textElement.innerHTML = '"I was slain too."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox_gaurdian_2_white.png"
            break;
            case 5:
                textElement.innerHTML = Items.getItemString("username") + " has risen the castle.  This is terrible."
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 6:
                textElement.innerHTML = '"Let me take care of him"'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 7:
                textElement.innerHTML = '"Nonsense!  We still have our two strongest guardians to defend us."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 8:
                textElement.innerHTML = '"He will not step a foot in this castle."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 9:
                textElement.innerHTML = '"Not to worry, as soon as he steps into the castle, I will eliminate them..."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox_gaurdian_3_white.png"
            break;
            case 10:
                textElement.innerHTML = '"Good.  You and the dragon are all I have left."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 11:
                textElement.innerHTML = '"Have no mercy, kill them on sight!"'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 12: 
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-7').delay(1000).fadeOut();
                $('#content').animate({opacity:1}, 1000,);
            break;
        }

        step++;
        document.getElementById("cutscenes-7-image-hidden").value = step;
    }



    static level_100_animation()
    {
        $("#body").fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500);
    }

    static blood_moon_animation()
    {
        document.getElementById('cutscenes-5-image').classList.add('shake');
        document.getElementById('cutscenes-5-image-blood-moon').classList.add('shake');
        $('#content').animate({opacity:0}, 1000, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");
            Sounds.play(Sounds.VARIABLE_EARTHQUAKE);
        });
        $('#cutscenes-5').fadeIn(2000, function(){
            $('#cutscenes-5-image-blood-moon').fadeIn(8000, function(){
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-5').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 4200, function() {
                    document.getElementById('cutscenes-5-image').classList.remove('shake');
                    document.getElementById('cutscenes-5-image-blood-moon').classList.remove('shake');

                    
                    Modals.open_image_modal('Bloodmoon', 'images/blood_beach.png', 'The blood moon is now active.<br /><br /><span style="color:grey">Feel free to toggle the blood moon from the combat panel.</span><br /><br /><b style="color:red">You have unlocked all blood moon combat areas!</b>', null, 'Close', null)
                    websocket.send("ACTIVATE_BLOODMOON")
                    Combat.modal_area_last_selected = "beach";
                });
                
            });
        });
        
    }

    static animateFaradoxLastPanel() {

        setTimeout(function() {
            $('#select-area-combat-faradox-final-1').delay(500).fadeIn();
            Sounds.play("https://cdn.idle-pixel.com/sounds/faradox-bosses.mp3")
        }, 1000)
            
        setTimeout(function() {
            $('#select-area-combat-faradox-final-2').delay(500).fadeIn();
            Sounds.play("https://cdn.idle-pixel.com/sounds/faradox-bosses.mp3")
        }, 3000)
        
        setTimeout(function() {
            $('#select-area-combat-faradox-final-3').delay(500).fadeIn();
            Sounds.play("https://cdn.idle-pixel.com/sounds/faradox-bosses.mp3")
        }, 5000)

        setTimeout(function() {
            $('#select-area-combat-faradox-final-4').delay(500).fadeIn();
            Sounds.play("https://cdn.idle-pixel.com/sounds/faradox-bosses.mp3")
        }, 7000)

        setTimeout(function() {
            $('#select-area-combat-faradox-final-5').delay(500).fadeIn();
            Sounds.play("https://cdn.idle-pixel.com/sounds/faradox-bosses.mp3")
        }, 9000)

        setTimeout(function() {
            $('#select-area-combat-faradox-final-6').delay(500).fadeIn();
            Sounds.play("https://cdn.idle-pixel.com/sounds/faradox-bosses.mp3")
        }, 11000)

        setTimeout(function() {
            websocket.send('FIGHT_FARADOX_FINAL_PANEL_FAKE=2')
        }, 13000)
    }

    static invisibility_beach_animation()
    {
        $(window).scrollTop(0);
        Sounds.play(Sounds.VARIABLE_FARADOX);
        $('#content').animate({opacity:0}, 4200, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");
        });

        $('#cutscenes-4').delay(5000).fadeIn();
    }

    
    static tsunami_animation()
    {
        $(window).scrollTop(0);
        Sounds.play("https://cdn.idle-pixel.com/sounds/tsunami.mp3");
        $('#content').animate({opacity:0}, 4200, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-blue");

            $('#content').animate({opacity:1}, 8200, function () {
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-blue");
            });

            setTimeout(function() {
                Modals.open_image_modal('TSUNAMI', 'images/badge_tsunami.png', 'Your badge has triggered a tsunami, which collected a bunch of loot from the ocean.<br /><br /><i class=color-grey>You may open this loot in your combat tab</i>', null, 'Close', null)
            }, 9000);
        });

       
        


    }

    static invisibility_beach_animation_text()
    {
        document.getElementById('cutscenes-4-next-btn').disabled = true;
        var step = document.getElementById("cutscenes-4-image-hidden").value;
        var textElement = document.getElementById("cutscenes-4-text");
        var imgElement = document.getElementById("cutscenes-4-image");
        
        setTimeout(function() {
            document.getElementById('cutscenes-4-next-btn').disabled = false;
        }, 1000);
    
        switch(parseInt(step))
        {
            case 1:
                textElement.innerHTML = '"Yes, the beach is empty.  There is no one here."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 2:
                textElement.innerHTML = '"Are we ready to cast the blood moon spell?"'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 3:
                textElement.innerHTML = '"Yes, let the blood moon rise!"'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 4:
                textElement.innerHTML = '"We need to be careful.  All monsters will become aggresive including our guardians.  They might attack us!"'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 5:
                textElement.innerHTML = Items.getItemString("username") + " is getting strong we must do this!"
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 6:
                textElement.innerHTML = '"But our own guardians might turn on us!"'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 7:
                textElement.innerHTML = '"The blood moon makes everyone aggresive!"'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 8:
                textElement.innerHTML = '"Nonesense!  I have given a special potion to all our guards, they will not be affected by the blood moon."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 9:
                textElement.innerHTML = '"It is way too risky.  This is a very powerful spell."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 10:
                textElement.innerHTML = '"NONESENSE!"'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 11:
                textElement.innerHTML = '"DO IT NOW!!!!"'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 12: 
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-4').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 2000, function() {
                    Animations.blood_moon_animation()
                });
            break;
        }

        step++;
        document.getElementById("cutscenes-4-image-hidden").value = step;
    }

    static give_crystals_wizard()
    {
        $(window).scrollTop(0);
        Sounds.play(Sounds.VARIABLE_FARADOX);
        $('#content').animate({opacity:0}, 4200, function () {
            $('#body').removeClass("background-primary-gradient")
            $('#body').addClass("background-black");
        });

        $('#cutscenes-3').delay(5000).fadeIn();
    }

    static give_crystals_wizard_text()
    {
        document.getElementById('cutscenes-3-next-btn').disabled = true;
        var step = document.getElementById("cutscenes-3-image-hidden").value;
        var textElement = document.getElementById("cutscenes-3-text");
        var imgElement = document.getElementById("cutscenes-3-image");
        
        setTimeout(function() {
            document.getElementById('cutscenes-3-next-btn').disabled = false;
        }, 1000);
    
        switch(parseInt(step))
        {
            case 1:
                textElement.innerHTML = '"It is an honour, Faradox."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 2:
                textElement.innerHTML = '"I cannot believe I got this adventurer to gain my trust."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 3:
                textElement.innerHTML = '"How was this achieved?"'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 4:
                textElement.innerHTML = '"I had to teach him magic, and combat presets."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 5:
                textElement.innerHTML = '"That is fine, we have the crystals now.  No one can stop us."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 6:
                textElement.innerHTML = '"I will distribute the crystals to my gaurdians.  They will keep them for safe keeping."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 7:
                textElement.innerHTML = '"Great, let us rule the world.  We should raid the village."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 8:
                textElement.innerHTML = '"Yes we will do just that."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 9:
                textElement.innerHTML = '"Perfect, and bring me the dwarf.  I want to talk to him before we expire him."'
                imgElement.src = "https://cdn.idle-pixel.com/images/wizard_large.png"
            break;
            case 10:
                textElement.innerHTML = '"Everyone but us will perish."'
                imgElement.src = "https://cdn.idle-pixel.com/images/faradox.png"
            break;
            case 11: 
                $('#body').addClass("background-primary-gradient")
                $('#body').removeClass("background-black");
                $('#cutscenes-3').delay(0).fadeOut();
                $('#content').animate({opacity:1}, 4200, function() {
                    websocket.send("QUEST=the_four_crystals~0")
                });
            break;
        }

        step++;
        document.getElementById("cutscenes-3-image-hidden").value = step;
    }

    static unlock_crystals()
    {
        var stardust_element = document.getElementById("menu-bar-crystals");
        var stardust_element_img = document.getElementById("menu-bar-crystals-img");
        stardust_element_img.style.width="300px";
        stardust_element.style.display = "";
        stardust_element_img.classList.add("animation-glow");

        $(stardust_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            stardust_element_img.classList.remove("animation-glow");
            websocket.send("QUEST=faradoxs_introduction~0");
            Modals.open_image_modal('Wizard', 'images/wizard.png', 'Wow ' + Items.getItem('username') + ', only two crystal to go!  Good work!', null, 'Close', null)
        });
    }

    static unlock_crystals_final()
    {
        var stardust_element = document.getElementById("menu-bar-crystals");
        var stardust_element_img = document.getElementById("menu-bar-crystals-img");
        stardust_element_img.style.width="300px";
        stardust_element.style.display = "";
        stardust_element_img.classList.add("animation-glow");

        $(stardust_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            stardust_element_img.classList.remove("animation-glow");
            Modals.open_image_modal('Faradox', 'images/faradox.png', Items.getItem('username') + ', You are risking your life.', null, 'Close', null)
        });
    }

    static unlock_crystals_final_2()
    {
        var stardust_element = document.getElementById("menu-bar-crystals");
        var stardust_element_img = document.getElementById("menu-bar-crystals-img");
        stardust_element_img.style.width="300px";
        stardust_element.style.display = "";
        stardust_element_img.classList.add("animation-glow");

        $(stardust_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            stardust_element_img.classList.remove("animation-glow");
            Modals.open_image_modal('Faradox', 'images/faradox.png', Items.getItem('username') + ', You think this guardian from the beach was worthy to me?  You only have two crystals.  I would watch your back.  I am coming for you.', null, 'Close', null)
        });
    }

    static unlock_crystals_final_3()
    {
        var stardust_element = document.getElementById("menu-bar-crystals");
        var stardust_element_img = document.getElementById("menu-bar-crystals-img");
        stardust_element_img.style.width="300px";
        stardust_element.style.display = "";
        stardust_element_img.classList.add("animation-glow");

        $(stardust_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            stardust_element_img.classList.remove("animation-glow");
            Modals.open_image_modal('Faradox', 'images/faradox.png', Items.getItem('username') + ', You are in dangerous territory.  Leave the castle now.', null, 'Close', null)
        });
    }

    static unlock_crystals_final_4()
    {
        var stardust_element = document.getElementById("menu-bar-crystals");
        var stardust_element_img = document.getElementById("menu-bar-crystals-img");
        stardust_element_img.style.width="300px";
        stardust_element.style.display = "";
        stardust_element_img.classList.add("animation-glow");

        $(stardust_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            stardust_element_img.classList.remove("animation-glow");
            Modals.open_image_modal('Faradox', 'images/faradox.png', Items.getItem('username') + ', .................', null, 'Close', null)
        });
    }

    static unlock_energy()
    {
        var energy_element = document.getElementById("menu-bar-energy");
        var energy_element_img = document.getElementById("menu-bar-energy-img");
        energy_element_img.style.width="300px";
        energy_element.style.display = "";
        energy_element_img.classList.add("animation-glow");
        websocket.send("ENERGY_UNLOCKED");

        $(energy_element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            energy_element_img.classList.remove("animation-glow"); 
        });
    }

    static unlock_achievements()
    {
        var element_img = document.getElementById("menu-bar-achievements-icon");
        element_img.style.width="300px";
        element_img.classList.add("animation-glow");

        $(element_img).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            element_img.classList.remove("animation-glow"); 
        });
    }

    static unlock_collection_log()
    {
        var image_tag = document.getElementById("menu-bar-collection-log-img");
        image_tag.style.width="300px";
        image_tag.classList.add("animation-glow");

        $(image_tag).animate({
            "width": 20,
            "height": 20,
        }, 5000, function() { 
            image_tag.classList.remove("animation-glow"); 
        });

        document.getElementById("menu-bar-collection-log-img").scrollIntoView();
    }

    static shake_hero() {
        document.getElementById("hero_idle_head").classList.add('shake');
        document.getElementById("hero_idle_body").classList.add('shake');
        document.getElementById("hero_idle_gloves").classList.add('shake');
        document.getElementById("hero_idle_legs").classList.add('shake');
        document.getElementById("hero_idle_boots").classList.add('shake');
        document.getElementById("hero_idle_amulet").classList.add('shake');
        document.getElementById("hero_idle_shield").classList.add('shake');
        document.getElementById("hero_idle_weapon").classList.add('shake');

        setTimeout(function() {
            document.getElementById("hero_idle_head").classList.remove('shake');
            document.getElementById("hero_idle_body").classList.remove('shake');
            document.getElementById("hero_idle_gloves").classList.remove('shake');
            document.getElementById("hero_idle_legs").classList.remove('shake');
            document.getElementById("hero_idle_boots").classList.remove('shake');
            document.getElementById("hero_idle_amulet").classList.remove('shake');
            document.getElementById("hero_idle_shield").classList.remove('shake');
            document.getElementById("hero_idle_weapon").classList.remove('shake');
        }, 500)
    }
    static shake_on(img_id)
    {
        document.getElementById(img_id).classList.add('shake');
    }

    static shake_off(img_id)
    {
        document.getElementById(img_id).classList.remove('shake');
    }

    static new_skill_animation(skill)
    {
        // document.getElementById("level-up-banner").innerHTML = "LEVEL UP: " + skill.toUpperCase() + " ("+level+")";
        // $("#level-up-banner").fadeIn();
        // setTimeout(function() {
        //     $("#level-up-banner").fadeOut();
        // }, 5000);

        document.getElementById("menu-bar-"+skill+"-level-up-on").style.color = 'cyan';
        document.getElementById("menu-bar-"+skill+"-level-up-on").innerHTML = "NEW SKILL!"; 
        document.getElementById("menu-bar-"+skill+"-level-up-off").style.display = "none";
        document.getElementById("menu-bar-"+skill+"-level-up-on").style.display = "";
        $("#menu-bar-"+skill+"-level-up").fadeIn();
        document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 1000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 1500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 2000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 2500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 3000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 3500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 4000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();

            document.getElementById("menu-bar-"+skill+"-level-up-off").style.display = "";
            document.getElementById("menu-bar-"+skill+"-level-up-on").style.display = "none";
        }, 4500);
        
    }

    static level_up_animation(skill, level)
    {
        // document.getElementById("level-up-banner").innerHTML = "LEVEL UP: " + skill.toUpperCase() + " ("+level+")";
        // $("#level-up-banner").fadeIn();
        // setTimeout(function() {
        //     $("#level-up-banner").fadeOut();
        // }, 5000);


        document.getElementById("menu-bar-"+skill+"-level-up-on").style.color = 'green';
        document.getElementById("menu-bar-"+skill+"-level-up-on").innerHTML = "LEVEL UP!"
        document.getElementById("menu-bar-"+skill+"-level-up-off").style.display = "none";
        document.getElementById("menu-bar-"+skill+"-level-up-on").style.display = "";
        $("#menu-bar-"+skill+"-level-up").fadeIn();
        document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 1000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 1500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 2000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 2500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 3000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();
        }, 3500);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = 'green';
            $("#menu-bar-"+skill+"-level-up").fadeIn();
        }, 4000);
        setTimeout(function() {
            document.getElementById("left-panel-item_panel-" + skill).style.backgroundColor = '';
            $("#menu-bar-"+skill+"-level-up").fadeOut();

            document.getElementById("menu-bar-"+skill+"-level-up-off").style.display = "";
            document.getElementById("menu-bar-"+skill+"-level-up-on").style.display = "none";
        }, 4500);
        
    }

    static level_up_animation_force_close()
    {
        $("#level-up-banner").fadeOut();
    }

    
    static animate_spending_coins()
    {
        $("#menu-bar-coins").effect("shake", {distance: 10}, 1000);
        $("#menu-bar-coins-2").effect("shake", {distance: 10}, 1000);
    }

    static achievement_perk(data)
    {
        Sounds.play(Sounds.VARIABLE_ACH_PERK);
        document.getElementById("achievement-perk-banner").innerHTML = data;
        $("#achievement-perk-banner").fadeIn();
        setTimeout(function() {
            $("#achievement-perk-banner").fadeOut();
        }, 5000);
    }

    static scrollText(icon, colorChosen, textChosen)
    {
        if(document.readyState === "complete") {
            var imgTag = "";
            if(icon != "none")
                imgTag = "<img src='https://cdn.idle-pixel.com/"+icon+"' class='img-50' /> ";
            
                
            var elementToAppend = $('<div class="scroller" style="z-index:100000;color:'+colorChosen+'">'+imgTag+textChosen+'</div>').appendTo('body');
            $(elementToAppend).css({position:"absolute", left:mouseX - 50,top:mouseY - 50});
            $(elementToAppend).animate({top: "-=50px"}, function() { 
            $(elementToAppend).fadeOut(1000, function() { $(this).remove(); });
            });
        }
    }

    static scrollTextOnElement(id, icon, colorChosen, textChosen, leftOffset, topOffset)
    {
        if(document.readyState === "complete") {
            var imgTag = "";
            if(icon != "none")  
                imgTag = "<img src='https://cdn.idle-pixel.com/"+icon+"' class='img-50' /> ";
            

            var elementChosen = document.getElementById(id);
            var topPos = elementChosen.getBoundingClientRect().top + window.scrollY;
            var leftPos = elementChosen.getBoundingClientRect().left + window.scrollX;
            leftPos += elementChosen.width/2;
            topPos += elementChosen.height/2;

            leftPos += leftOffset;
            topPos += topOffset;

            var elementToAppend = $('<div class="scroller" style="z-index:100000;color:'+colorChosen+'">'+imgTag+textChosen+'</div>').appendTo('body');
                $(elementToAppend).css({position:"absolute", left:leftPos,top:topPos});
                $(elementToAppend).animate({top: "-=50px"}, function() { 
                $(elementToAppend).fadeOut(1000, function() { $(this).remove(); });
            });
        }
    }
    
}