class Arcade
{
  static clicks_arcade_ticket_1()
  {
    Modals.open_action_modal("ARCADE TICEKT", "images/clown.png", "Oh!  We have a new player!  Want to redeem your ticket and play a minigame for money??", "Yes", "No", "ARCADE_TICKET_1");
  }

  static clicks_arcade_ticket_2()
  {
    Modals.open_action_modal("ARCADE TICEKT", "images/clown.png", "Oh!  A returning player!  Want to redeem your ticket and play a minigame for coins??", "Yes", "No", "SECOND_ARCADE_TICKET_1");
  }

  static clicks_rock()
  {
    document.getElementById("arcade_1_minigame_clicks").innerHTML = parseInt(document.getElementById("arcade_1_minigame_clicks").innerHTML) + 1;
    Animations.shake_on("arcade_1_img");
  }

  static start_arcade_1_timer()
  {
    setTimeout(
      function() {
        websocket.send("ARCADE=" + "1" + "~" + document.getElementById("arcade_1_minigame_clicks").innerHTML);
      },
      20000
    )
  }

  static load_arcade_card_game()
  {
    document.getElementById("arcade-2-section").innerHTML = "<img class='hover' id='arcade-2-card-0' onclick='Arcade.clicks_arcade_2_card(0)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-1' onclick='Arcade.clicks_arcade_2_card(1)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-2' onclick='Arcade.clicks_arcade_2_card(2)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-3' onclick='Arcade.clicks_arcade_2_card(3)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-4' onclick='Arcade.clicks_arcade_2_card(4)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-5' onclick='Arcade.clicks_arcade_2_card(5)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-6' onclick='Arcade.clicks_arcade_2_card(6)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-7' onclick='Arcade.clicks_arcade_2_card(7)' src='https://cdn.idle-pixel.com/images/arcade_card.png' /><img class='hover' id='arcade-2-card-8' onclick='Arcade.clicks_arcade_2_card(8)' src='https://cdn.idle-pixel.com/images/arcade_card.png' />";
  }

  static arcade_2_cards_clicked_array = []
  static clicks_arcade_2_card(id) {
    Arcade.arcade_2_cards_clicked_array.push(id);

    if(Arcade.arcade_2_cards_clicked_array.length == 4)
      Arcade.arcade_2_cards_clicked_array.shift();

    for(var i = 0; i <= 8; i++) {
      document.getElementById("arcade-2-card-" + i).style.border = "";
    }

    for(var i = 0; i < Arcade.arcade_2_cards_clicked_array.length; i++)
    {
      var card_id = Arcade.arcade_2_cards_clicked_array[i];
      document.getElementById("arcade-2-card-" + card_id).style.border = "3px solid lime";
    }

    if(Arcade.arcade_2_cards_clicked_array.length == 3)
    {
      document.getElementById("arcade-2-btn").style.display = "";
    }
  }
}