class CardData {

    static data = null;

    static getData() {
        return CardData.data;
    }

    static fetchData() {
        if(CardData.data == null) {
            $.get("../../get-tcg-info/", function(result) {
                CardData.data = result;
            });
        }
    }

    static getCardHTML(id, var_name, holo) {
        var data = CardData.data[var_name];
        var holo_style = "";
        var holo_title_style = "";
        if(holo) holo_style = "holo";
        if(holo) holo_title_style = "shine";

        var html =  "<div onclick='Modals.open_tcg_give_card(null, \""+id+"\")' style='"+data['border_css']+data['background_css']+"' class='tcg-card hover'>";
                html += "<div class='tcg-card-title'>";
                    html += "<span>" + data['label'] + "</span>";
                html += "</div>";
                html += "<div class='tcg-card-inner "+holo_style+"'>"; 
                    html += "<img src='https://cdn.idle-pixel.com/images/"+data['image']+"' class='w50'>";
                html += "</div>";
                html += "<div class='tcg-card-inner-text'>";
                    html += "<b>["+data['description_title']+"]</b>";
                    html += "<br />";
                    html += "<br />";
                html += "<span class='color-grey'>";
                    if(holo) {
                        html += "<span class='"+holo_title_style+"'>𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴<br />𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈<br />𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴<br />𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈</span>" /*data['description']*/;
                    } else {
                        html += "𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴<br />𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈<br />𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴<br />𓄜𓈤𓈤𓊙𓐈𓀚𓁁𓂧𓃢𓃴𓄜𓈤𓈤𓊙𓐈" /*data['description']*/;
                    }
                    
                html += "</span>";
            html += "</div>";
        html += "</div>";

        return html;
    }
}