
class Fishing
{
   
    static BOAT_TIMERS = {
        "row_boat": 3600 *3,
        "canoe_boat": 3600*6,
        "stardust_boat": 3600*10,
        "pirate_ship": 3600*24,
        "submarine_boat": 3600*48,
    }
    static clicks_bad_fishing_net()
    {
        Modals.open_image_modal("Fishing", "images/bad_fishing_net.png", "Attempt to catch fish?", "Cast Net", null, "BAD_FISHING_NET");
    }

    //tool = fishing_net, fishing_rod or harpoon
    static getFishingNetToolData(tool)
    {
        if(Items.getItem("diamond_" + tool))
            return ["diamond_" + tool, "none"];
        
        if(Items.getItem("ruby_" + tool))
            return ["ruby_" + tool, "diamond"];
        
        if(Items.getItem("emerald_" + tool))
            return ["emerald_" + tool, "ruby"];
    
        if(Items.getItem("sapphire_" + tool))
            return ["sapphire_" + tool, "emerald"];

        if(Items.getItem(tool))
            return [tool, "sapphire"];

        return ["none", "none"];
    }

    static clicks_boat(name)
    {
        if(Items.getItem(name + '_timer') == 1)
            websocket.send('BOAT_COLLECT=' + name);
        else if(name == 'pirate_ship')
        {
            Modals.toggle('modal-pirate-ship-send')
        }
        else
            Modals.open_image_modal('Send Boat', 'images/'+name+'.png', 'Send out to the ocean?<br /><br /><img src=https://cdn.idle-pixel.com/images/clock.png /> ' + format_time(Fishing.BOAT_TIMERS[name]) + "<br /><br /><span class='color-grey'>You sent out this boat "+Items.getItem(name + "_sent_total")+" times.</span>", 'Send', 'Cancel', 'BOAT_SEND=' + name)
    }

    static has_aquarium_with_fish()
    {
        return (
            Items.getItem('raw_shrimp_aquarium') > 0 ||
            Items.getItem('raw_anchovy_aquarium') > 0 ||
            Items.getItem('raw_sardine_aquarium') > 0 ||
            Items.getItem('raw_crab_aquarium') > 0 ||
            Items.getItem('raw_piranha_aquarium') > 0
        )
    }
}