class MonsterDescriptions
{
    static data = {
        //area
        "chicken": {
            "HP": 5,
            "desc": "A great source of feathers.",
            "stratergy": "None",
        },
        "rat": {
            "HP": 3,
            "desc": "A great source of cheese.",
            "stratergy": "None",
        },
        "spider": {
            "HP": 2,
            "desc": "A great source of string used to make a fishing net.",
            "stratergy": "None",
        },
        "lizard": {
            "HP": 2,
            "desc": "Primarly hunted for their skin.",
            "stratergy": "None",
        },
        "bee": {
            "HP": 2,
            "desc": "Drops a stinger, a weapon useful and easy to get weapon.  It also drops honey which can help with energy.",
            "stratergy": "None",
        },
        //area
        "snake": {
            "HP": 10,
            "desc": "Snakes are known for spitting poison.",
            "stratergy": "None",
        },
        "ants": {
            "HP": 5,
            "desc": "Ants are a great source of ant needles.  Be careful, when the turn their backs on you they will deal a lot of damage with their spikes.",
            "stratergy": "None",
        },
        "wolf": {
            "HP": 15,
            "desc": "A great source of meat.",
            "stratergy": "None",
        },
        "forest_ent": {
            "HP": 10,
            "desc": "This very much alive tree will always give a strange leaf. If you're lucky, you'll get the strange leaf fertilizer.",
            "stratergy": "None",
        },
        "thief": {
            "HP": 10,
            "desc": "Watch out, sometimes they can steal your coins.",
            "stratergy": "None",
        },

        //area
        "bear": {
            "HP": 10,
            "desc": "Great way to collect bear fur and turn into armour.",
            "stratergy": "The caves are dark, this will reduce your hit chance by 50% unless you somehow get a lighsource.  A lightsource is a common drop from a goblin.",
        },
        "goblin": {
            "HP": 10,
            "desc": "Goblins is the naive version of a thief from the forest.  They also have long toenails for some reason.",
            "stratergy": "The caves are dark, this will reduce your hit chance by 50% unless you somehow get a lighsource.  A lightsource is a common drop from a goblin.",
        },
        "bat": {
            "HP": 4,
            "desc": "Hunted for batskin. They can be difficult to kill without a lightsource.",
            "stratergy": "The caves are dark, this will reduce your hit chance by 50% unless you somehow get a lighsource.  A lightsource is a common drop from a goblin.",
        },
        "skeleton": {
            "HP": 6,
            "desc": "Low HP, but can hit quite high.  The skeleton sword/shield are quite strong.",
            "stratergy": "The caves are dark, this will reduce your hit chance by 50% unless you somehow get a lighsource.  A lightsource is a common drop from a goblin.",
        },

        //area
        "fire_hawk": {
            "HP": 25,
            "desc": "A great source of fire feathers - which allows you to craft fire arrows.",
            "stratergy": "Weak to ice arrows - but not required for a kill although it can help.",
        },
        "fire_snake": {
            "HP": 12,
            "desc": "Like all snakes, this one spits out lava dealing massive damage.",
            "stratergy": "Weak to ice arrows - but not required for a kill although it can help.",
        },
        "fire_golem": {
            "HP": 12,
            "desc": "Fire golem's are known for carrying bombs.  They don't actually attack people, but will self destruct when in danger.",
            "stratergy": "Weak to ice arrows - but not required for a kill although it can help.<br /><br />Also carries a bomb which he uses to self destruct.  Be careful when using fire spells while the bomb is in his hands.",
        },
        "fire_witch": {
            "HP": 30,
            "desc": "The leader of the volcano.",
            "stratergy": "Weak to ice arrows - but not required for a kill although it can help.<br /><br />Uses a powerful charging ability when it has 1 health left.",
        },

        //area
        "ice_hawk": {
            "HP": 80,
            "desc": "A great source of ice feathers - which allows you to craft ice arrows.",
            "stratergy": "It's very cold up here and you will need to wear warm clothing to avoid cold damage.",
        },
        "ice_witch": {
            "HP": 20,
            "desc": "The Fire Witch's Sister.",
            "stratergy": "It's very cold up here and you will need to wear warm clothing to avoid cold damage.<br /><br />Like the Fire Witch, she will charge when she reaches 1 hp for massive damage.  She will then heal herself to full life.  Bring her down to 0 hp a second time to finish her off.",
        },
        "ice_golem": {
            "HP": 45,
            "desc": "Loves to collect bows and arrows.  This monster drops a ton of arrows and a long bow base.",
            "stratergy": "It's very cold up here and you will need to wear warm clothing to avoid cold damage.",
        },
        "yeti": {
            "HP": 120,
            "desc": "The leader of the northern fields.  Carries a massive club for damage.",
            "stratergy": "It's very cold up here and you will need to wear warm clothing to avoid cold damage.<br /><br />Can freeze you into an ice block.  You'll need to cast a fire spell to get out of the ice block, or reflect it back on him.  He will shake before using this spell.",
        },
        //area
        "ghost": {
            "HP": 30,
            "desc": "The dominant monster in the mansion.",
            "stratergy": "Ghosts have a chance to go invisibile, making all your attacks miss.  Make sure you time this when using spells to avoid wasting mana.",
        },
        "grandma": {
            "HP": 30,
            "desc": "Grandma isn't very strong, she relies on healing herself to survive.",
            "stratergy": "You should try to stack as much damage when she has low hp.",
        },
        "exorcist": {
            "HP": 70,
            "desc": "Extremely powerful.  Her base hit is over 50 damage every time, ignoring defence.",
            "stratergy": "It's critical to avoid or reflect this damage at all costs.  Be prepared as she will not shake or show any indiciation of hitting this high.",
        },
        "reaper": {
            "HP": 90,
            "desc": "The leader of the mansion.  His scythe and robes are much wanted by adventurers.",
            "stratergy": "Watch for his glowing eyes.  This indicates a strong attack.  He can glow multiple times per fight.",
        },

        //area
        "shark": {
            "HP": 60,
            "desc": "Monsters in the ocean will heal if it rains.",
            "stratergy": "Sharks can quickly sneak up on you for a massive bite.  Make sure you are ready to counter this.  A shark biting is very fast.",
        },
        "sea_soldier": {
            "HP": 50,
            "desc": "Holds the trident and a very strong helmet. Monsters in the ocean will heal if it rains.",
            "stratergy": "None.",
        },
        "puffer_fish": {
            "HP": 50,
            "desc": "I probably shouldn't get close to this.  Monsters in the ocean will heal if it rains.",
            "stratergy": "Using close combat will cause me to take damage.  Range weapons do not work in the oceans as arrows can't travel in water.  I'll need a long spear for this monster.",
        },
        "saltwater_crocodile": {
            "HP": 300,
            "desc": "The modern dinosaur.  The crocodile hide is very valuable.",
            "stratergy": "Crocodiles may VERY quickly use a bite attack.  Make sure you counter this.  As soon as you see his mouth open, counter the attack.",
        },

        //blood fields
        "blood_chicken": {
            "HP": 100,
            "desc": "A great source of feathers.<br /><br /><span style='color:red'>Blood moon makes this monster much stronger.</span>",
            "stratergy": "None",
            "tablette": "field_tablette_1",
        },
        "blood_rat": {
            "HP": 100,
            "desc": "A great source of cheese.<br /><br /><span style='color:red'>Blood moon makes this monster much stronger.</span>",
            "stratergy": "None",
            "tablette": "field_tablette_2",
        },
        "blood_spider": {
            "HP": 20,
            "desc": "A great source of string.<br /><br /><span style='color:red'>Blood moon makes this monster much stronger.</span>",
            "stratergy": "None",
            "tablette": "field_tablette_3",
        },
        "blood_lizard": {
            "HP": 100,
            "desc": "Primarly hunted for their skin.<br /><br /><span style='color:red'>Blood moon makes this monster much stronger.</span>",
            "stratergy": "None",
            "tablette": "field_tablette_5",
        },
        "blood_bee": {
            "HP": 20,
            "desc": "Drops a stinger, a weapon useful and easy to get weapon.  It also drops honey which can help with energy.<br /><br /><span style='color:red'>Blood moon makes this monster much stronger.</span>",
            "stratergy": "None",
            "tablette": "field_tablette_4",
        },

        "blood_snake": {
            "HP": 100,
            "desc": "Snakes are known for spitting poison.<br /><br /><span style='color:red'>Blood moon makes this monster much stronger.</span>",
            "stratergy": "Make sure to use your spells when the snake spits on you.",
            "tablette": "forest_tablette_1",
        },

        "blood_ants": {
            "HP": 100,
            "desc": "Ants have a high attack speed and an extremely fast powerful attack.<br /><br /><span style='color:red'>Blood moon makes this monster much stronger.</span>",
            "stratergy": "When the ants turn around and show there stinger towards you, be quick to reflect or invis the damage.<br /><br />You need an extremely fast reaction time for this.",
            "tablette": "forest_tablette_2",
        },

        "blood_wolf": {
            "HP": 100,
            "desc": "A great source of meat.",
            "stratergy": "None",
            "tablette": "forest_tablette_3",
        },

        "blood_forest_ent": {
            "HP": 100,
            "desc": "A great source of logs and stranger leaves.",
            "stratergy": "None",
            "tablette": "forest_tablette_4",
        },

        "blood_thief": {
            "HP": 50,
            "desc": "Iron daggers!",
            "stratergy": "None",
            "tablette": "forest_tablette_5",
        },


        "blood_bat": {
            "HP": 50,
            "desc": "I must be careful as this bat attacks every second.",
            "stratergy": "None",
            "tablette": "cave_tablette_3",
        },

        "blood_goblin": {
            "HP": 80,
            "desc": "This goblin is wearing armour and a special light ring.  It has a lot of armour.",
            "stratergy": "None",
            "tablette": "cave_tablette_2",
        },

        "blood_bear": {
            "HP": 50,
            "desc": "A great source of bear fur.",
            "stratergy": "None",
            "tablette": "cave_tablette_1",
        },

        "blood_skeleton": {
            "HP": 100,
            "desc": "A great source bonemeal with blood bones, but very strong.",
            "stratergy": "None",
            "tablette": "cave_tablette_4",
        },

        "blood_fire_hawk": {
            "HP": 300,
            "desc": "Attacks at an increased rate.",
            "stratergy": "Weak to ice arrows.",
            "tablette": "volcano_tablette_2",
        },

        "blood_fire_snake": {
            "HP": 300,
            "desc": "A blood fire snake which can spit 3 fire balls.",
            "stratergy": "Weak to ice arrows.  I should be careful and be ready to reflect or avoid the fire ball spit attack.",
            "tablette": "volcano_tablette_1",
        },

        "blood_fire_golem": {
            "HP": 160,
            "desc": "Blood fire golem's are known for carrying tnt.  They don't actually attack people, but will self destruct when in danger.",
            "stratergy": "Weak to ice arrows - I should try to kill him as quick as possible to avoid him setting off a tnt.<br /><br />Also carries a tnt which he uses to self destruct.  Be careful when using fire spells while the tnt is in his hands.",
            "tablette": "volcano_tablette_3",
        },

        "blood_fire_witch": {
            "HP": 200,
            "desc": "The blood fire witch has learned to use reflect against you when it uses its charging spell.",
            "stratergy": "Weak to ice arrows.<br /><br />I should be ready when this enemy reaches 1 hp as it will charge and do massive damage.  The best strategy is to reflect this - however the witch learned to reflect back the damage to you.  You need to avoid this by being invisible.  Doing so will confuse the witch and it will forget to heal.",
            "tablette": "volcano_tablette_4",
        },
    }
}


class Chicken
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/chicken_monster_idle_0.png", "images/chicken_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
}

class BloodChicken
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_chicken_monster_idle_0.png", "images/blood_chicken_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class BloodExperimentOne
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_experiment_one_monster_idle_0.png", "images/blood_experiment_one_monster_idle_1.png"];
    static idle_animation_speed = 100;
}

class BloodExperimentTwo
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_experiment_two_monster_idle_0.png", "images/blood_experiment_two_monster_idle_1.png"];
    static idle_animation_speed = 100;
}

class BloodExperimentThree
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_experiment_three_monster_idle_0.png", "images/blood_experiment_three_monster_idle_1.png"];
    static idle_animation_speed = 100;
}

class BloodRat
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_rat_monster_idle_0.png", "images/blood_rat_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class BloodSpider
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_spider_monster_idle_0.png", "images/blood_spider_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class BloodLizard
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_lizard_monster_idle_0.png", "images/blood_lizard_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class BloodBee
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_bee_monster_idle_0.png", "images/blood_bee_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class Rat
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/rat_monster_idle_0.png", "images/rat_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
}

class Spider
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/spider_monster_idle_0.png", "images/spider_monster_idle_1.png", "images/spider_monster_idle_2.png"];
    static idle_animation_speed = 20;
    
}

class Snake
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/snake_monster_idle_0.png", "images/snake_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static spit_animation = ["images/snake_monster_spit_0.png", "images/snake_monster_spit_1.png", "images/snake_monster_spit_2.png", "images/snake_monster_spit_3.png"];
    static spit_animation_speed = 15;
}


class Cloud
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/cloud_monster_idle_0.png", "images/cloud_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static charge_animation = ["images/cloud_monster_charge_0.png", "images/cloud_monster_charge_1.png"];
    static charge_animation_speed = 100;
}


class Shark
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/shark_monster_idle_0.png", "images/shark_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static bite_animation = ["images/shark_monster_bite_0.png", "images/shark_monster_bite_1.png"];
    static bite_animation_speed = 15;
}

class SaltwaterCrocodile
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/saltwater_crocodile_monster_idle_0.png", "images/saltwater_crocodile_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static bite_animation = ["images/saltwater_crocodile_monster_bite_0.png", "images/saltwater_crocodile_monster_bite_0.png"];
    static bite_animation_speed = 30;
}

class CastleSaltwaterCrocodile
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/castle_saltwater_crocodile_monster_idle_0.png", "images/castle_saltwater_crocodile_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static bite_animation = ["images/castle_saltwater_crocodile_monster_bite_0.png", "images/castle_saltwater_crocodile_monster_bite_0.png"];
    static bite_animation_speed = 30;
}


class SeaSoldier
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/sea_soldier_monster_idle_0.png", "images/sea_soldier_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class PufferFish
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/puffer_fish_monster_idle_0.png", "images/puffer_fish_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class BloodSnake
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/blood_snake_monster_idle_0.png", "images/blood_snake_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static spit_animation = ["images/blood_snake_monster_idle_0.png", "images/blood_snake_monster_spit_0.png", "images/blood_snake_monster_spit_1.png", "images/blood_snake_monster_spit_2.png"];
    static spit_animation_speed = 15;
    
    
}

class FireSnake
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/fire_snake_monster_idle_0.png", "images/fire_snake_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static spit_animation = ["images/fire_snake_monster_spit_0.png", "images/fire_snake_monster_spit_1.png", "images/fire_snake_monster_spit_2.png", "images/fire_snake_monster_spit_3.png"];
    static spit_animation_speed = 15;
}

class BloodFireSnake
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/blood_fire_snake_monster_idle_0.png", "images/blood_fire_snake_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static spit_animation = ["images/blood_fire_snake_monster_spit_0.png", "images/blood_fire_snake_monster_spit_1.png", "images/blood_fire_snake_monster_spit_2.png", "images/blood_fire_snake_monster_spit_3.png"];
    static spit_animation_speed = 15;
}

class FireGolem
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/fire_golem_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static bomb_animation = [
        "images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png",
        "images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png",
        "images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png",
        "images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png",
        "images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png","images/fire_golem_monster_bomb_0.png",
    
        "images/fire_golem_monster_bomb_1.png",
        "images/fire_golem_monster_bomb_2.png",
        "images/fire_golem_monster_bomb_3.png",
        "images/fire_golem_monster_bomb_4.png",

        "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png",
        "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png",
        "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png", "images/fire_golem_monster_bomb_5.png",
        
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
        "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png", "images/fire_golem_monster_bomb_6.png",
    
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
        "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", "images/fire_golem_monster_bomb_7.png", 
    ];

    
    static bomb_animation_speed = 10;
}

class BloodFireGolem
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/blood_fire_golem_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static bomb_animation = [
        "images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png",
        "images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png",
        "images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png",
        "images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png",
        "images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png","images/blood_fire_golem_monster_bomb_0.png",
    
        "images/blood_fire_golem_monster_bomb_1.png",
        "images/blood_fire_golem_monster_bomb_2.png",
        "images/blood_fire_golem_monster_bomb_3.png",
        "images/blood_fire_golem_monster_bomb_4.png",

        "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png",
        "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png",
        "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png", "images/blood_fire_golem_monster_bomb_5.png",
        
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
        "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png", "images/blood_fire_golem_monster_bomb_6.png",
    
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
        "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", "images/blood_fire_golem_monster_bomb_7.png", 
    ];

    
    static bomb_animation_speed = 10;
}

class CastleGolem
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/castle_golem_idle_0.png", "images/castle_golem_idle_1.png"];
    static idle_animation_speed = 50;

    static bomb_animation = [
        "images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png",
        "images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png",
        "images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png",
        "images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png",
        "images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png","images/castle_golem_bomb_0.png",
    ];

    
    static bomb_animation_speed = 1000;
}


class EvilPirate
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/evil_pirate_monster_idle_0.png", "images/evil_pirate_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static cannon_animation = [
        "images/evil_pirate_monster_cannon_0.png",
        "images/evil_pirate_monster_cannon_1.png",
        "images/evil_pirate_monster_cannon_2.png",
        "images/evil_pirate_monster_cannon_3.png",
        "images/evil_pirate_monster_cannon_4.png",
    ];

    static cannon_animation_speed = 15;
}

class TreasureChestMimic
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/treasure_chest_mimic_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static bite_animation = ["images/treasure_chest_mimic_monster_bite_0.png", "images/treasure_chest_mimic_monster_bite_0.png", "images/treasure_chest_mimic_monster_bite_0.png"];
    static bite_animation_speed = 50;
}


class GreenTreasureChestMimic
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/green_treasure_chest_mimic_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static bite_animation = ["images/green_treasure_chest_mimic_monster_bite_0.png", "images/green_treasure_chest_mimic_monster_bite_0.png", "images/green_treasure_chest_mimic_monster_bite_0.png"];
    static bite_animation_speed = 50;
}

class RedTreasureChestMimic
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/red_treasure_chest_mimic_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static bite_animation = ["images/red_treasure_chest_mimic_monster_bite_0.png", "images/red_treasure_chest_mimic_monster_bite_0.png", "images/red_treasure_chest_mimic_monster_bite_0.png"];
    static bite_animation_speed = 50;
}

class MixedTreasureChestMimic
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/mixed_treasure_chest_mimic_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static bite_animation = ["images/mixed_treasure_chest_mimic_monster_bite_0.png", "images/mixed_treasure_chest_mimic_monster_bite_0.png", "images/mixed_treasure_chest_mimic_monster_bite_0.png"];
    static bite_animation_speed = 50;
}

class Ants
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/ants_monster_idle_0.png", "images/ants_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static poke_animation = ["images/ants_monster_poke_0.png", "images/ants_monster_poke_1.png"];
    static poke_animation_speed = 50;
    
    
}

class BloodAnts
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/blood_ants_monster_idle_0.png", "images/blood_ants_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static poke_animation = ["images/blood_ants_monster_poke_0.png", "images/blood_ants_monster_poke_1.png"];
    static poke_animation_speed = 50;
}

class CastleAnts
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/castle_ants_monster_idle_0.png", "images/castle_ants_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static poke_animation = ["images/castle_ants_monster_poke_0.png", "images/castle_ants_monster_poke_1.png"];
    static poke_animation_speed = 50;
}

class Wolf
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/wolf_monster_idle_0.png", "images/wolf_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
    
}


class BloodWolf
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static loop_animation = true;

    static idle_animation = ["images/blood_wolf_monster_idle_0.png", "images/blood_wolf_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
    
}

class Bee
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/bee_monster_idle_0.png", "images/bee_monster_idle_1.png"];
    static idle_animation_speed = 10;
    
}


class Boss1
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/boss_1_monster_idle_0.png", "images/boss_1_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class Lizard
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/lizard_monster_idle_0.png", "images/lizard_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
}

class Ent
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/ent_monster_idle_0.png", "images/ent_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
}

class Robot1
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_1_monster_idle_0.png"];
    static idle_animation_speed = 50;
}

class Robot2
{
    static animation_selected = "idle_animation";
    static animation_index = 0;

    static idle_animation = ["images/robot_2_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static charge_animation = ["images/robot_2_monster_charge_0.png", "images/robot_2_monster_charge_0.png"];
    static charge_animation_speed = 100; 
}


class Robot14
{
    static animation_selected = "idle_animation";
    static animation_index = 0;

    static idle_animation = ["images/robot_14_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static charge_animation = ["images/robot_14_monster_charge_0.png", "images/robot_14_monster_charge_0.png"];
    static charge_animation_speed = 50; 
}


class Robot3
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_3_monster_idle_0.png"];
    static idle_animation_speed = 50;
}

class Robot4
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_4_monster_idle_0.png"];
    static idle_animation_speed = 50;
}


class Robot5
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_5_monster_idle_0.png", "images/robot_5_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class Robot6
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_6_monster_idle_0.png", "images/robot_6_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class Robot7
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_7_monster_idle_0.png"];
    static idle_animation_speed = 50;
}

class Robot8
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_8_monster_idle_0.png"];
    static idle_animation_speed = 50;
}

class Robot9
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_9_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static tank_animation = [
        "images/robot_9_monster_charge_0.png",
        "images/robot_9_monster_charge_1.png",
        "images/robot_9_monster_charge_0.png",
        "images/robot_9_monster_charge_1.png",
        "images/robot_9_monster_charge_0.png",
        "images/robot_9_monster_charge_1.png",
        "images/robot_9_monster_charge_0.png",
        "images/robot_9_monster_charge_1.png",
        "images/robot_9_monster_charge_0.png",
        "images/robot_9_monster_charge_1.png",
        "images/robot_9_monster_charge_0.png",
        "images/robot_9_monster_charge_1.png",
        "images/robot_9_monster_charge_0.png",
        "images/robot_9_monster_charge_1.png",
    ];
    static tank_animation_speed = 10;
}

class Robot10
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_10_monster_idle_0.png"];
    static idle_animation_speed = 50;
}


class Robot12
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_12_monster_idle_0.png"];
    static idle_animation_speed = 50;
}

class Robot13
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_13_monster_idle_0.png"];
    static idle_animation_speed = 50;
}


class Robot11
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/robot_11_monster_idle_0.png"];
    static idle_animation_speed = 50;

    static fire_animation = [
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
        "images/robot_11_monster_fire_0.png",
    ];
    static fire_animation_speed = 200;
}


class ForestEnt
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/forest_ent_monster_idle_0.png", "images/forest_ent_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
}

class BloodForestEnt
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_forest_ent_monster_idle_0.png", "images/blood_forest_ent_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class Thief
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/thief_monster_idle_0.png", "images/thief_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
}

class BloodThief
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_thief_monster_idle_0.png", "images/blood_thief_monster_idle_1.png"];
    static idle_animation_speed = 50; 
}



class ThiefLeader
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/thief_leader_monster_idle_0.png", "images/thief_leader_monster_idle_1.png"];
    static idle_animation_speed = 50;
    
}

class Bear
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/bear_monster_idle_0.png", "images/bear_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class BloodBear
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_bear_monster_idle_0.png", "images/blood_bear_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class FireHawk
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/fire_hawk_monster_idle_0.png", "images/fire_hawk_monster_idle_1.png"];
    static idle_animation_speed = 20;
}

class BloodFireHawk
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_fire_hawk_monster_idle_0.png", "images/blood_fire_hawk_monster_idle_1.png"];
    static idle_animation_speed = 20;
}

class IceHawk
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/ice_hawk_monster_idle_0.png", "images/ice_hawk_monster_idle_1.png"];
    static idle_animation_speed = 20;
}

class IceGolem
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/ice_golem_monster_idle_0.png", "images/ice_golem_monster_idle_1.png"];
    static idle_animation_speed = 50;
}




class GemGoblin
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/gem_goblin_monster_idle_0.png", "images/gem_goblin_monster_idle_1.png"];
    static idle_animation_speed = 50; 
}

class BloodGemGoblin
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_gem_goblin_monster_idle_0.png", "images/blood_gem_goblin_monster_idle_1.png"];
    static idle_animation_speed = 50;  
}


class FloatingSkull
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/floating_skull_monster_idle_0.png"];
    static idle_animation_speed = 50;
}


class Bat
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/bat_monster_idle_0.png", "images/bat_monster_idle_1.png", "images/bat_monster_idle_2.png", "images/bat_monster_idle_3.png"];
    static idle_animation_speed = 10;
}

class BloodBat
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_bat_monster_idle_0.png", "images/blood_bat_monster_idle_1.png"];
    static idle_animation_speed = 10;
}



class Goblin
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/goblin_monster_idle_0.png", "images/goblin_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class BloodGoblin
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_goblin_monster_idle_0.png", "images/blood_goblin_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class Skeleton
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/skeleton_monster_idle_0.png", "images/skeleton_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class BloodSkeleton
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_skeleton_monster_idle_0.png", "images/blood_skeleton_monster_idle_1.png"];
    static idle_animation_speed = 50;
}



class IceWitch
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/ice_witch_monster_idle_0.png", "images/ice_witch_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class FireWitch
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/fire_witch_monster_idle_0.png", "images/fire_witch_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class BloodFireWitch
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/blood_fire_witch_monster_idle_0.png", "images/blood_fire_witch_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class Yeti
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/yeti_monster_idle_0.png", "images/yeti_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class CastleYeti
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/castle_yeti_monster_idle_0.png", "images/castle_yeti_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class GuardianOne
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/guardian_one_monster_idle_0.png"];
    static idle_animation_speed = 50;
    static red_animation = ["images/guardian_one_monster_red_0.png"];
    static red_animation_speed = 50;
    static green_animation = ["images/guardian_one_monster_green_0.png"];
    static green_animation_speed = 50;
    static blue_animation = ["images/guardian_one_monster_blue_0.png"];
    static blue_animation_speed = 50;
}



class GuardianTwo
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/guardian_two_monster_idle_0.png"];
    static idle_animation_speed = 50;
}


class FaradoxInv
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/faradox_inv_monster_idle_0.png", "images/faradox_inv_monster_idle_1.png"];
    static idle_animation_speed = 50;
}


class GuardianThree
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/guardian_three_monster_idle_0.png", "images/guardian_three_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static red_arrow_animation = [
        "images/guardian_three_monster_red_arrow_0.png",
        "images/guardian_three_monster_red_arrow_1.png",
        "images/guardian_three_monster_red_arrow_2.png",
        "images/guardian_three_monster_red_arrow_3.png",
        "images/guardian_three_monster_red_arrow_4.png",
        "images/guardian_three_monster_red_arrow_5.png",
    ];
    static red_arrow_animation_speed = 15;

    static green_arrow_animation = [
        "images/guardian_three_monster_green_arrow_0.png",
        "images/guardian_three_monster_green_arrow_1.png",
        "images/guardian_three_monster_green_arrow_2.png",
        "images/guardian_three_monster_green_arrow_3.png",
        "images/guardian_three_monster_green_arrow_4.png",
        "images/guardian_three_monster_green_arrow_5.png",
    ];
    static green_arrow_animation_speed = 15;

    static blue_arrow_animation = [
        "images/guardian_three_monster_blue_arrow_0.png",
        "images/guardian_three_monster_blue_arrow_1.png",
        "images/guardian_three_monster_blue_arrow_2.png",
        "images/guardian_three_monster_blue_arrow_3.png",
        "images/guardian_three_monster_blue_arrow_4.png",
        "images/guardian_three_monster_blue_arrow_5.png",
    ];
    static blue_arrow_animation_speed = 15;

    static black_arrow_animation = [
        "images/guardian_three_monster_black_arrow_0.png",
        "images/guardian_three_monster_black_arrow_1.png",
        "images/guardian_three_monster_black_arrow_2.png",
        "images/guardian_three_monster_black_arrow_3.png",
        "images/guardian_three_monster_black_arrow_4.png",
        "images/guardian_three_monster_black_arrow_5.png",
    ];
    static black_arrow_animation_speed = 15;
}

class GuardianFour
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    
    static idle_animation = ["images/guardian_four_monster_idle_0.png", "images/guardian_four_monster_idle_1.png"];
    static idle_animation_speed = 50;

    static flying_animation = ["images/guardian_four_monster_flying_0.png", "images/guardian_four_monster_flying_1.png", "images/guardian_four_monster_flying_2.png" ,"images/guardian_four_monster_flying_3.png"];
    static flying_animation_speed = 25;

    static fire_animation = ["images/guardian_four_monster_fire_0.png", "images/guardian_four_monster_fire_1.png", "images/guardian_four_monster_fire_2.png" ,"images/guardian_four_monster_fire_3.png" ,"images/guardian_four_monster_fire_4.png"];
    static fire_animation_speed = 10;

    static ice_animation = ["images/guardian_four_monster_ice_0.png", "images/guardian_four_monster_ice_1.png", "images/guardian_four_monster_ice_2.png" ,"images/guardian_four_monster_ice_3.png" ,"images/guardian_four_monster_ice_4.png"];
    static ice_animation_speed = 10;

    static whip_animation = ["images/guardian_four_monster_whip_0.png", "images/guardian_four_monster_whip_1.png", "images/guardian_four_monster_whip_2.png" ,"images/guardian_four_monster_whip_3.png" ,"images/guardian_four_monster_whip_4.png"];
    static whip_animation_speed = 10;
}

class Ghost
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/ghost_monster_idle_0.png", "images/ghost_monster_idle_1.png"];
    static idle_animation_speed = 25;
}


class Exorcist
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/exorcist_monster_idle_0.png"];
    static idle_animation_speed = 50;
}

class Grandma
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/grandma_monster_idle_0.png", "images/grandma_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class GhostMiner
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/ghost_miner_monster_idle_0.png", "images/ghost_miner_monster_idle_1.png"];
    static idle_animation_speed = 50;
}

class Reaper
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/reaper_monster_idle_0.png", "images/reaper_monster_idle_1.png"];
    static charge_animation = ["images/reaper_monster_charge_0.png", "images/reaper_monster_charge_1.png", "images/reaper_monster_charge_2.png", "images/reaper_monster_charge_3.png", "images/reaper_monster_charge_4.png", "images/reaper_monster_charge_5.png"];
    
    static charge_animation_speed = 15;
    static idle_animation_speed = 50;
}


class Tank
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/tank_monster_idle_0.png", "images/tank_monster_idle_1.png"];
    static idle_animation_speed = 50;
    

    static tank_animation = [
        "images/tank_monster_charge_0.png",
        "images/tank_monster_charge_1.png",
        "images/tank_monster_charge_0.png",
        "images/tank_monster_charge_1.png",
        "images/tank_monster_charge_0.png",
        "images/tank_monster_charge_1.png",
        "images/tank_monster_charge_0.png",
        "images/tank_monster_charge_1.png",
        "images/tank_monster_charge_0.png",
        "images/tank_monster_charge_1.png",
        "images/tank_monster_charge_0.png",
        "images/tank_monster_charge_1.png",
        "images/tank_monster_charge_0.png",
        "images/tank_monster_charge_1.png",
    ];
    static tank_animation_speed = 10;
}

//halloween 2023

class ZombiePurple
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/zombie_purple_monster_idle_0.png"];
    static idle_animation_speed = 100;
}
class ZombieGreen
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/zombie_green_monster_idle_0.png"];
    static idle_animation_speed = 100;
}
class ZombieRed
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/zombie_red_monster_idle_0.png"];
    static idle_animation_speed = 100;
}
class ZombieBlue
{
    static animation_selected = "idle_animation";
    static animation_index = 0;
    static idle_animation = ["images/zombie_blue_monster_idle_0.png"];
    static idle_animation_speed = 100;
}


class Monsters
{

    static angel_crystal_activated = false;
    static animate_animation_speed(slug, seconds)
    {
        if(slug == "ice_hawk")
        {
            IceHawk.idle_animation_speed = 3;
            setTimeout(
                function() {
                    IceHawk.idle_animation_speed = 20;
                },
                seconds * 1000
            )
        }
    }

    static animate_sprite(animation_selected, loop)
    {
        var monster_name = Items.getItem("monster_name");
        var monster_split_array = monster_name.split("_");
        var className = "";
        for(var i = 0; i < monster_split_array.length; i++)
        {
            className += monster_split_array[i].charAt(0).toUpperCase() + monster_split_array[i].slice(1);
        }
        if(className === "None") return;
        get_class(className).animation_index = 0;
        get_class(className).animation_selected = animation_selected;
        get_class(className).loop_animation = loop;
    }

    

   static open_info_dialogue(data)
   {
        document.getElementById("modal-monster-lookup-content").innerHTML = data;
        Modals.toggle('modal-monster-lookup');
   }

    static get_hitsplat_start_y_location()
    {
        switch(Items.getItem("monster_name"))
        {
            case "ghost_miner":
                return 200;
            case "bat":
            case "blood_bee":
            case "fire_hawk":
            case "ice_hawk":
            case "ghost":
            case "grandma":
            case "fire_witch":
            case "ice_witch":
            case "shark":
            case "sea_soldier":
                return 250;
            default:
                return 450;
        }
    }

    /*
    * BELOW IS ALL THE ANIMATIONS RELATED TO CANVASES - INCLUDES HERO ANIMATIONS TOO
    */
    static shake_animation = false;
    static glow_animation = false;
    static glow_animation_value = "100";
    static invisibile = false;
    static hero_frozen = false;
    static monster_frozen = false;
    static animate_canvas(variable, value, type)
    {
        if(type == "boolean")
        {
            Monsters[variable] = value === "true";
        }
        else if(type == "int")
        {
            Monsters[variable] = parseInt(value);
        }
        else
            Monsters[variable] = value;
    }
    /*
    * END OF CANVAS ANIMATIONS ABOVE
    */

    //check animate_canvas above
    static animate_canvas_reset_variables()
    {
        Monsters.shake_animation = false;
        Monsters.glow_animation = false;
        Monsters.hero_frozen = false;
        Monsters.monster_frozen = false;
        Monsters.invisibile = false;
        Monsters.glow_animation_value = 100; // % which is normal glow
    }

    static preload_images(MonsterClass)
    {
        _fighting_monster_canvas_context.globalAlpha = 0.0;
        var keys = Object.keys(MonsterClass);
        for(var i = 0; i < keys.length; i++)
        {
            var key = keys[i];
            if(key.endsWith("_animation"))
            {
                for(var j = 0; j < MonsterClass[key].length; j++)
                {
                    _fighting_monster_canvas_context.drawImage(
                        Cache.getImage(
                            MonsterClass[key][j], 
                            MonsterClass[key][j],
                        )
                        ,0
                        ,0
                    );
                }
            }
        }       
        _fighting_monster_canvas_context.globalAlpha = 1.0;
    }


    static tick_canvas(MonsterClass)
    {
        _fighting_monster_canvas_context.clearRect(0, 0, _fighting_monster_canvas.width, _fighting_monster_canvas.height);

       
        
        if(Fighting.dim_monster_image) //a successful hit - dim image
        {
            _fighting_monster_canvas_context.globalAlpha = 0.5;
        }
        if(Fighting.dim_monster_image_death)//a successful kill - dim image, fade out, greyscale
        {
            _fighting_monster_canvas_context.filter = 'grayscale(1)';
            if(Fighting.play_monster_death_sound) {
                Sounds.play("https://cdn.idle-pixel.com/sounds/kill.mp3")
                Fighting.play_monster_death_sound = false;
            }
            
            $( "#combat-canvas-monster" ).fadeOut(1000, function() {
                $("#combat-canvas-monster").fadeIn(5000);
                _fighting_monster_canvas_context.filter = 'grayscale(0)';
                Fighting.dim_monster_image_death = false;
                Fighting.play_monster_death_sound = true;
            });
        }


        var monster_position_x = 0;
        var monster_position_y = 0;
        if(Monsters.shake_animation || Monsters.angel_crystal_activated)
        {
            monster_position_x = rand(-3, 3)
        }
        if(Monsters.glow_animation)
        {
            _fighting_monster_canvas_context.filter = "brightness("+Monsters.glow_animation_value+"%)";
            Monsters.glow_animation_value = parseInt(Monsters.glow_animation_value) + 10;
        }
        else
        {
            _fighting_monster_canvas_context.filter = "brightness(100%)";
        }
        
        if(Monsters.invisibile)
            _fighting_monster_canvas_context.globalAlpha = 0.1;
        else
            _fighting_monster_canvas_context.globalAlpha = 1.0;

        if(Monsters.angel_crystal_activated) {
            _fighting_monster_canvas_context.drawImage(
                Cache.getImage(
                    "images/crystal_angel_monster_idle_0.png",
                    "images/crystal_angel_monster_idle_0.png",
                )
                ,0
                ,0
            );
        }
        else {
            _fighting_monster_canvas_context.drawImage(
            
                Cache.getImage(
                    MonsterClass[MonsterClass.animation_selected][MonsterClass.animation_index], 
                    MonsterClass[MonsterClass.animation_selected][MonsterClass.animation_index]
                )
                ,monster_position_x
                ,monster_position_y
            );
        }
       
        _fighting_monster_canvas_context.globalAlpha = 1;

        if(Fighting.tick_tracker % MonsterClass[MonsterClass.animation_selected + "_speed"] == 0 && !Monsters.monster_frozen)
        {
            MonsterClass.animation_index++;
            if(MonsterClass.animation_index >= MonsterClass[MonsterClass.animation_selected].length)
            {
                MonsterClass.animation_index = 0;
                if(!MonsterClass.loop_animation) {
                    MonsterClass.animation_selected = "idle_animation";
                }
            }
            
        }

        if(Monsters.monster_frozen)
        {
            _fighting_monster_canvas_context.fillStyle = "rgba(0,255,255, 0.2)";
            _fighting_monster_canvas_context.strokeStyle = "rgba(0,255,255)";
            _fighting_monster_canvas_context.fillRect(0,50,500,550);
            _fighting_monster_canvas_context.beginPath();
            _fighting_monster_canvas_context.rect(0,50,500,550);
            _fighting_monster_canvas_context.stroke();
            _fighting_monster_canvas_context.font = "30px pixel";
            _fighting_monster_canvas_context.strokeText("FROZEN", 10, 80);
        }

        // _fighting_monster_canvas_context.strokeStyle = "rgba(155,155,155)";
        // _fighting_monster_canvas_context.font = "10px Arial";
        // _fighting_monster_canvas_context.strokeText(Items.getItem("current_monster_fight_speed") - 1, 240, 590);
       
        Monsters.manage_hitplats();
    }

    static manage_hitplats()
    {
        for (var key in Fighting.active_hitsplats_monster_map) 
        {
            Fighting.active_hitsplats_monster_map[key].draw(_fighting_monster_canvas_context);
        }
    }

    static get_total_drops_for_loot_button(monster)
    {
        if(monster == "chicken")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "chicken_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "chicken_raw_chicken"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "chicken_feathers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "chicken_dotted_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "chicken_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "chicken_lime_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "chicken_gold_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "rat")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "rat_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "rat_cheese"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "rat_dotted_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "rat_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "rat_lime_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "rat_gold_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "spider")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "spider_string"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "spider_dotted_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "spider_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "spider_lime_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "spider_gold_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "bee")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "bee_honey"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bee_stinger"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "lizard")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "lizard_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "lizard_lizard_skin"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "lizard_lizard_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "lizard_lizard_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "lizard_lizard_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "lizard_lizard_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "lizard_lizard_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "snake")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "snake_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "snake_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "snake_poison"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "snake_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "snake_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "snake_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "ants")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "ants_ant_needles"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ants_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ants_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ants_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ants_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "wolf")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "wolf_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "wolf_raw_meat"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "wolf_max_heart_1"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "wolf_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "wolf_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "wolf_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "wolf_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;

    
            return [completed, total]
        }

        if(monster == "thief")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "thief_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "thief_coins"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "thief_iron_dagger"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "thief_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "thief_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "thief_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "thief_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;

    
            return [completed, total]
        }

        if(monster == "forest_ent")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "forest_ent_strange_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_strange_leaf_fertilizer"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_oak_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_willow_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_maple_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_oak_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_willow_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "forest_ent_maple_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;

    
            return [completed, total]
        }

        if(monster == "bear")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "bear_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bear_train_cart_piece_1"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bear_bear_fur"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bear_bear_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bear_bear_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bear_bear_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bear_bear_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bear_bear_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "goblin")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "goblin_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_lantern"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_train_cart_piece_2"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_goblin_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_stone"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_copper"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_iron"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_silver"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "goblin_gold"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "bat")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "bat_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bat_train_cart_piece_3"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bat_bat_skin"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bat_bat_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bat_bat_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bat_bat_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bat_bat_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "bat_bat_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "skeleton")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "skeleton_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "skeleton_train_cart_piece_4"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "skeleton_skeleton_sword"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "skeleton_skeleton_shield"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "skeleton_train_cart"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "skeleton_skull"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "skeleton_bone_amulet"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "skeleton_promethium"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "fire_hawk")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "fire_hawk_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "fire_hawk_fire_feathers"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "fire_snake")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "fire_snake_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "fire_snake_fire_spellscroll"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "fire_golem")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "fire_golem_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "fire_golem_bomb"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "fire_witch")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            
            testingFor = "fire_witch_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "fire_witch_string"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "fire_witch_fire_crystal"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "fire_witch_max_heart_2"; total++; if(Items.getItem(testingFor) > 0) completed++;

    
            return [completed, total]
        }

        if(monster == "ice_hawk")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "ice_hawk_ice_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_hawk_ice_feathers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_hawk_pine_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_hawk_pine_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;

    
            return [completed, total]
        }

        if(monster == "ice_golem")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "ice_golem_ice_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_golem_wooden_arrows"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_golem_fire_arrows"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_golem_ice_arrows"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_golem_pine_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_golem_long_bow_frame"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_golem_pine_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "ice_witch")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "ice_witch_ice_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_witch_string"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_witch_pine_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_witch_max_heart_3"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_witch_max_mana_2"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ice_witch_pine_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "yeti")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "yeti_ice_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "yeti_pine_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "yeti_ice_crystal"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "yeti_pine_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "yeti_club"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "ghost")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";
            testingFor = "ghost_ghost_essence"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "ghost_green_gaurdian_key"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "grandma")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "grandma_ghost_essence"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "grandma_heal_upgrade_spellscroll"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "grandma_green_gaurdian_key"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "exorcist")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "exorcist_ghost_essence"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "exorcist_oxygen_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "exorcist_oxygen_tank"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "exorcist_green_gaurdian_key"; total++; if(Items.getItem(testingFor) > 0) completed++;
    
            return [completed, total]
        }

        if(monster == "reaper")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "reaper_ghost_essence"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "reaper_green_gaurdian_key"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "reaper_scythe"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "reaper_reaper_hood"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "reaper_reaper_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "reaper_reaper_skirt"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "reaper_reaper_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "reaper_reaper_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;

    
            return [completed, total]
        }

        if(monster == "shark")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "shark_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "shark_seaweed"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "shark_super_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "shark_raw_bloated_shark"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "shark_flippers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "shark_shark_tooth"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "shark_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "shark_mega_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "shark_crystal_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            return [completed, total]
        }

        if(monster == "sea_soldier")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "sea_soldier_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "sea_soldier_seaweed"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "sea_soldier_super_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "sea_soldier_flippers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "sea_soldier_trident"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "sea_soldier_sea_helmet"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "sea_soldier_mega_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "sea_soldier_crystal_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            return [completed, total]
        }

        
        if(monster == "puffer_fish")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "puffer_fish_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "puffer_fish_puffer_needles"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "puffer_fish_seaweed"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "puffer_fish_super_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "puffer_fish_flippers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "puffer_fish_mega_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "puffer_fish_crystal_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            return [completed, total]
        }

        if(monster == "saltwater_crocodile")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "saltwater_crocodile_big_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_seaweed"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "saltwater_crocodile_crocodile_hide"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_super_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_flippers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_crocodile_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_crocodile_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_crocodile_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_crocodile_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_crocodile_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_mega_bait"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "saltwater_crocodile_crystal_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            return [completed, total]
        }

        if(monster == "blood_chicken")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_chicken_blood_chicken_foot"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_chicken_raw_chicken"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_feathers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_field_tablette_1"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_dotted_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_egg"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_lime_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_chicken_gold_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;

            return [completed, total]
        }

        if(monster == "blood_rat")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_rat_blood_rat_tail"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_rat_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_rat_cheese"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_rat_field_tablette_2"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_rat_dotted_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_rat_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_rat_lime_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_rat_gold_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;

            return [completed, total]
        }

        if(monster == "blood_spider")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_spider_blood_spider_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_spider_string"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_spider_dotted_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_spider_field_tablette_3"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_spider_green_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_spider_lime_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_spider_gold_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;

            return [completed, total]
        }

        if(monster == "blood_bee")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_bee_blood_bee_wings"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bee_honey"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_bee_stinger"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bee_field_tablette_4"; total++; if(Items.getItem(testingFor) > 0) completed++;

            return [completed, total]
        }

        if(monster == "blood_lizard")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_lizard_blood_lizard_head"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_lizard_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_lizard_lizard_skin"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_lizard_field_tablette_5"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_lizard_lizard_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_lizard_lizard_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_lizard_lizard_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_lizard_lizard_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_lizard_lizard_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_snake")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_snake_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_snake_blood_snake_head"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_snake_forest_tablette_1"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_snake_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_snake_poison"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_snake_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_snake_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_snake_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;

            return [completed, total]
        }

        if(monster == "blood_ants")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_ants_ant_needles"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_ants_blood_ant_remains"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_ants_forest_tablette_2"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_ants_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_ants_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_ants_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_ants_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;

            return [completed, total]
        }

        if(monster == "blood_wolf")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_wolf_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_wolf_blood_wolf_paw"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_wolf_raw_meat"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_wolf_max_heart_5"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_wolf_forest_tablette_3"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_wolf_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_wolf_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_wolf_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_wolf_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_forest_ent")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_forest_ent_blood_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_strange_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_forest_ent_stranger_leaf"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_oak_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_forest_tablette_4"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_willow_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_maple_logs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_oak_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_willow_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_maple_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_forest_ent_stardust_tree_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_thief")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_thief_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_thief_blood_thief_skull"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_thief_coins"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_thief_forest_tablette_5"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_thief_iron_dagger"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_thief_dotted_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_thief_green_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_thief_lime_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_thief_gold_leaf_seeds"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_bear")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_bear_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bear_blood_bear_paw"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_bear_bear_fur"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bear_cave_tablette_1"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bear_bear_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bear_bear_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bear_bear_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bear_bear_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bear_bear_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_goblin")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_goblin_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_blood_goblin_fingers"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_goblin_lantern"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_ring_of_light"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_blood_goblin_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_cave_tablette_2"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_stone"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_copper"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_iron"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_silver"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_goblin_gold"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_bat")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_bat_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bat_blood_bat_wing"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_bat_bat_skin"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bat_cave_tablette_3"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bat_bat_mask"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bat_bat_body"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bat_bat_legs"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bat_bat_gloves"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_bat_bat_boots"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_skeleton")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_skeleton_blood_bones"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_skeleton_blood_skeleton_ribcage"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_skeleton_skeleton_sword"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_skeleton_skeleton_shield"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_skeleton_cave_tablette_4"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_skeleton_bone_amulet"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_skeleton_promethium"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_fire_snake")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_fire_snake_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_snake_blood_fire_snake_tongue"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_fire_snake_fire_upgrade_spellscroll"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_snake_volcano_tablette_1"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_fire_hawk")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_fire_hawk_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_hawk_blood_fire_hawk_wing"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_fire_hawk_fire_feathers"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_hawk_volcano_tablette_2"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_fire_golem")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_fire_golem_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_golem_blood_fire_golem_head"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_fire_golem_volcano_tablette_3"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_golem_bomb"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_golem_tnt"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        if(monster == "blood_fire_witch")
        {
            var total = 0;
            var completed = 0;
            var testingFor = "";

            testingFor = "blood_fire_witch_ashes"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_witch_string"; total++; if(Items.getItem(testingFor) > 0) completed++;            
            testingFor = "blood_fire_witch_blood_fire_witch_web"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_witch_volcano_tablette_4"; total++; if(Items.getItem(testingFor) > 0) completed++;
            testingFor = "blood_fire_witch_reflect_upgrade_spellscroll"; total++; if(Items.getItem(testingFor) > 0) completed++;


            return [completed, total]
        }

        return [0,'not_implemented']
        
    }
}

