class Needle
{
    static needle_active = false;

    static clicks_needle()
    {
        if(!Needle.needle_active)
        {
            Modals.open_image_modal("NEEDLE", "images/" + Needle.getNeedleToolData()[0] + ".png", "Click on the armour you wish to undo.<br /><b>Works on: " + Needle.getNeedleToolData()[2] + "</b>.<br /><br /><span class='color-grey'>Can be upgraded with gems.</span>", "Close", null , "");
            Needle.needle_active = true;
        }
        else
        {
            Modals.open_image_modal("NEEDLE", "images/" + Needle.getNeedleToolData()[0] + ".png", "Needle disactivated.",  "Close", null , "");
            Needle.needle_active = false;
        }
    }

    static getNeedleToolData()
    {
        if(Items.getItem("diamond_needle"))
            return ["diamond_needle", "none", "lizard, bat, bear, polar bearm, dark bat"];
        
        if(Items.getItem("ruby_needle"))
            return ["ruby_needle", "diamond", "lizard, bat, bear, polar bear"];
        
        if(Items.getItem("emerald_needle"))
            return ["emerald_needle", "ruby", "lizard, bat, bear"];
    
        if(Items.getItem("sapphire_needle"))
            return ["sapphire_needle", "emerald", "lizard, bat"];

        if(Items.getItem("needle"))
            return ["needle", "sapphire", "lizard"];

        return ["none", "none", ""];
    }

    static isActive(equipment)
    {
        if(!Needle.needle_active)
            return false;

        var current_needle = Needle.getNeedleToolData()[0];
        
        switch(equipment)
        {
            case "lizard_mask":
            case "lizard_body":
            case "lizard_legs":
            case "lizard_boots":
            case "lizard_gloves":

            case "bat_mask":
            case "bat_body":
            case "bat_legs":
            case "bat_boots":
            case "bat_gloves":

            case "bear_mask":
            case "bear_body":
            case "bear_legs":
            case "bear_boots":
            case "bear_gloves":
                Modals.open_input_dialogue_with_value(
                    equipment,
                       "USE NEEDLE",
                       "<img src='https://cdn.idle-pixel.com/images/"+equipment+".png' class='w100' /><br /><br /><span class='color-grey'>How many?</span>",
                       "1",
                       "USE_NEEDLE"
                );
            break;
        }

        Needle.needle_active = false;
        return true;
    }
}