var drag_focus_item = null;
function onDragStart(event) 
{
    drag_focus_item = event.target.getAttribute("data-item");
    event
      .dataTransfer
      .setData('text/plain', event.target.id);
}

function onDragOver(event) 
{
    event.preventDefault();
    event.target.style.filter = "brightness(20%)";
}

function onDrop(event) 
{
    const id = event
      .dataTransfer
      .getData('text');

      var patch_id = event.target.id.split("-").pop();
      websocket.send("PLANT=" + drag_focus_item + "~" + patch_id);
      drag_focus_item = null;
}

function onDragEnd()
{
    document.getElementById("farming-patch-1").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-2").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-3").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-4").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-5").style.filter = "brightness(100%)";

    document.getElementById("farming-patch-image-1").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-image-2").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-image-3").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-image-4").style.filter = "brightness(100%)";
    document.getElementById("farming-patch-image-5").style.filter = "brightness(100%)";
}