client_ticks = 0;
title_animation_active = false;
title_animation_trigger = false;

function loop()
{
    Activities.loop();


    if(CToe.call_timer > 0) {
        CToe.call_timer--;
    }

    if(Globals.currentPanel == "panel-settings")
    {
        Globals.ping = Date.now();
        websocket.send('CHECK_PING');
    }
    
    if(document.hidden && Globals.tabActive) 
	{
		websocket.send("TAB_OFF");
        Globals.tabActive = false;
	}

	if(!document.hidden && !Globals.tabActive)
	{
		websocket.send("TAB_ON");
        Globals.tabActive = true;
	}

    if(Globals.currentPanel == "panel-mining")
    {
        document.getElementById("panel-mining-level").innerHTML = get_level(Items.getItem("mining_xp"), false);
    }

    if(Globals.currentPanel == "panel-crafting")
    {
        document.getElementById("panel-crafting-level").innerHTML = get_level(Items.getItem("crafting_xp"), false);
    }

    if(Globals.currentPanel == "panel-gathering")
    {
        document.getElementById("panel-gathering-level").innerHTML = get_level(Items.getItem("gathering_xp"), false);
    }

    if(Globals.currentPanel == "panel-fishing")
    {
        document.getElementById("panel-fishing-level").innerHTML = get_level(Items.getItem("fishing_xp"), false);
    }
    if(Globals.currentPanel == "panel-criptoe-market")
    {
        document.getElementById("criptoe-market-time").innerHTML = get_utc_time();
    }


    

    if(Globals.currentPanel == "panel-invention")
    {
        document.getElementById("panel-invention-level").innerHTML = get_level(Items.getItem("invention_xp"), false);
    }

    if(Globals.currentPanel == "panel-farming")
    {
        
        Farming.refresh();
    }

    if(Globals.currentPanel == "panel-woodcutting")
    {
        Woodcutting.refresh();
    }

    if(Globals.currentPanel == "panel-breeding")
    {
        document.getElementById("panel-breeding-level").innerHTML = get_level(Items.getItem("breeding_xp"), false);
    }

    if(Globals.currentPanel == "panel-brewing")
    {
        document.getElementById("panel-brewing-level").innerHTML = get_level(Items.getItem("brewing_xp"), false);
    }

    if(Globals.currentPanel == "panel-cooking")
    {
        document.getElementById("panel-cooking-level").innerHTML = get_level(Items.getItem("cooking_xp"), false);
    }

    if(Globals.currentPanel == "panel-fishing")
    {
        document.getElementById("panel-fishing-level").innerHTML = get_level(Items.getItem("fishing_xp"), false);
    }

    if(Globals.currentPanel == "panel-breeding") {
        Breeding.refresh_animals_data(Items.getItem("animal_data"));
    }

    if(Globals.currentPanel == "panel-combat")
    {
        document.getElementById("panel-melee-level").innerHTML = get_level(Items.getItem("melee_xp"), false);
        document.getElementById("panel-archery-level").innerHTML = get_level(Items.getItem("archery_xp"), false);
        document.getElementById("panel-magic-level").innerHTML = get_level(Items.getItem("magic_xp"), false);
        Magic.refreshSpellStatus();
        Combat.refreshLabelCombat();
    }

    if(Globals.currentPanel == "panel-penguin" && Globals.tabActive)
    {
        if(client_ticks % 10 == 0) {
            websocket.send('REFRESH_PENGUIN_TICKETS');
        }
    }

    if(Globals.currentPanel == "panel-events-yeti_boss") {
        EventsYetiBoss.tick();
    }

    if(Globals.currentPanel == "panel-events-seed_piles") {
        EventsSeedPiles.tick();
    }

    
    if(Globals.currentPanel == "panel-achievements")
    {
        if(document.getElementById('hard-ach-gatherer-total') != null)
            document.getElementById('hard-ach-gatherer-total').innerHTML = format_number(Gathering.get_total_bag_from_gatherer());
    }
    if(Needle.needle_active)
    {
        show_element("notification-needle");
        set_image_src("notification-needle-image", "images/" + Needle.getNeedleToolData()[0] + ".png");
    }
    else
    {
        hide_element("notification-needle");
    }

    if(Globals.currentPanel == "panel-combat-canvas")
    {
        //dark caves
        if(
            Items.getItem("monster_name") == "bear" ||
            Items.getItem("monster_name") == "bat" ||
            Items.getItem("monster_name") == "skeleton" ||
            Items.getItem("monster_name") == "blood_bear" ||
            Items.getItem("monster_name") == "blood_bat" || 
            Items.getItem("monster_name") == "blood_skeleton"
        )
        {
            if(Items.getItem("shield") == "lantern" || Items.getItem('ring_of_light_equipped') >= 1)
                document.getElementById("body").style.filter = "brightness(100%)"
            else
                document.getElementById("body").style.filter = "brightness(10%)"
        }
    }
    else
        document.getElementById("body").style.filter = "brightness(100%)"


    if(document.getElementById('game-panels-combat-items-area-select').style.display == '') {
        Combat.refresh_select_combat_are_labels();
    }
    
    refresh_xp_required_labels();
    
    if(client_ticks < 1) 
    {
        $('.custom-tooltip').remove()
    }
        client_ticks++;


    if(Globals.tabActive)
    {
        title_animation_active = false;
    }

    if(!title_animation_active)
    {
        document.getElementById("title-tag").innerHTML = "IDLE PIXEL";
        document.getElementById("browse-tab-fav-icon").href = "https://cdn.idle-pixel.com/images/favicon.ico"
    }
    else
    {
        if(title_animation_trigger)
        {
            title_animation_trigger = false;
            document.getElementById("browse-tab-fav-icon").href = "https://cdn.idle-pixel.com/images/favicon_notif.ico"
        }
        else
        {
            title_animation_trigger = true;
            document.getElementById("browse-tab-fav-icon").href = "https://cdn.idle-pixel.com/images/favicon.ico"
        }
        
    }

    if(Items.getItem("update_log_version") != Items.getItem("update_log_version_clicked")) {
        if(Items.getItem("skeleton_kills") > 0) {
            document.getElementById("update-log-notif").style.display = "";
        }
    } else {
        document.getElementById("update-log-notif").style.display = "none";
    }

    Gathering.notificationGatheringUnique();
    

    //quests label
    var story_quests_total = Quests.getQuestsData();
    var optional_quests_data = Quests.getOptionalQuestsData();
    var mini_quests_data = Quests.getMiniQuestsData();
    var quests_completed_total = parseInt(story_quests_total[0]) + parseInt(optional_quests_data[0]) + parseInt(mini_quests_data[0]);
    var quests_total = parseInt(story_quests_total[1]) + parseInt(optional_quests_data[1]) + parseInt(mini_quests_data[1]);
    var color = 'silver';
    if(quests_completed_total == quests_total) color = "cyan";
    document.getElementById("menu-bar-quests-label-totals").innerHTML = " <span style='color:"+color+"'>("+quests_completed_total+"/"+quests_total+")</span>";

    //achievements label
    var ach_data = Achievements.get_achievement_count_data();
    var ach_completed = ach_data[0];
    var ach_total = ach_data[1];
    var color = 'silver';
    if(ach_completed == ach_total) color = "cyan";
    document.getElementById("menu-bar-ach-label-totals").innerHTML = " <span style='color:"+color+"'>("+ach_completed+"/"+ach_total+")</span>";

    if(Items.getItem("invention_unlocked") == 0) {
        if(Items.getItem("blood_moon_unlocked") >= 1 &&
        get_level(Items.getItem('mining_xp')) >= 60 &&
        get_level(Items.getItem('crafting_xp')) >= 60 &&
        get_level(Items.getItem('crafting_xp')) >= 60 &&
        get_level(Items.getItem('gathering_xp')) >= 60 &&
        get_level(Items.getItem('farming_xp')) >= 60 &&
        get_level(Items.getItem('brewing_xp')) >= 60 &&
        get_level(Items.getItem('woodcutting_xp')) >= 60 &&
        get_level(Items.getItem('cooking_xp')) >= 60 &&
        get_level(Items.getItem('fishing_xp')) >= 60
        ) {
            document.getElementById("menu-bar-invention-table-btn-wrapper-unlockable").style.display = "";
        }
    }

    if(Items.getItem("menu_bar_show_energy_potential_on")) {
        show_element("left-menu-bar-energy-potential-label")
        show_element("left-menu-bar-energy-potential-label-2")
        if(client_ticks % 10) document.getElementById("left-menu-bar-energy-potential-label").innerHTML = format_number(Cooking.get_potential_energy());
    }   else {
        hide_element("left-menu-bar-energy-potential-label")
        hide_element("left-menu-bar-energy-potential-label-2")
    }

    
}