function refresh_background(slug, isBuyable) {
    var ele = document.getElementById("shop-"+slug);
    if(ele != null) {
        if(isBuyable) {
            ele.classList.add("game-shop-table-entry-green");
            ele.classList.remove("game-shop-table-entry-red");
        } else {
            ele.classList.remove("game-shop-table-entry-green");
            ele.classList.add("game-shop-table-entry-red");
        }
    }
}

function refresh_shop()
{

    var testingForBuyPrice = 0;
    var testingForBuyItem = null;

    var redLabelColor = "red";
    var greenLabelColor = "green";

    testingForBuyPrice = 15;
    testingForBuyItem = "pickaxe";
    if(Items.getItem("coins") >= testingForBuyPrice) {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = greenLabelColor;
        refresh_background(testingForBuyItem, true);
    }
    else {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = redLabelColor;
        refresh_background(testingForBuyItem, false);
    }
    
    
    testingForBuyPrice = 50;
    testingForBuyItem = "wooden_sword";
    if(Items.getItem("coins") >= testingForBuyPrice) {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = greenLabelColor;
        refresh_background(testingForBuyItem, true);
    }
    else {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = redLabelColor;
        refresh_background(testingForBuyItem, false);
    }
    
    testingForBuyPrice = 50;
    testingForBuyItem = "wooden_bow";
    if(Items.getItem("coins") >= testingForBuyPrice) {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = greenLabelColor;
        refresh_background(testingForBuyItem, true);
    }
    else {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = redLabelColor;
        refresh_background(testingForBuyItem, false);
    }
    

    testingForBuyPrice = 50;
    testingForBuyItem = "wooden_staff";
    if(Items.getItem("coins") >= testingForBuyPrice) {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = greenLabelColor;
        refresh_background(testingForBuyItem, true);
    }
    else {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = redLabelColor;
        refresh_background(testingForBuyItem, false);
    }
    
    testingForBuyPrice = 2000;
    testingForBuyItem = "player_market";
    if(Items.getItem("coins") >= testingForBuyPrice) {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = greenLabelColor;
        refresh_background(testingForBuyItem, true);
    }
    else {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = redLabelColor;
        refresh_background(testingForBuyItem, false);
    } 
    
    testingForBuyPrice = 5000;
    testingForBuyItem = "donor_shop";
    if(Items.getItem("coins") >= testingForBuyPrice) { 
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = greenLabelColor;
        refresh_background(testingForBuyItem, true);
    }
    else {
        document.getElementById("shop-coins-label-" + testingForBuyItem).style.color = redLabelColor;
        refresh_background(testingForBuyItem, false);
    }
    

    var labelColorsCoinsElements = document.querySelectorAll('[data-switch-label-color-coins]')
    for(var i = 0; i < labelColorsCoinsElements.length; i++) {
        var element = labelColorsCoinsElements[i];
        var coinsRequired = element.innerHTML;
        var originalLabel = element.innerHTML;
        coinsRequired = coinsRequired.replaceAll(",", "");
        coinsRequired = get_number_with_letters(coinsRequired);
        testingForBuyItem = element.getAttribute("data-switch-label-color-item");
        if(Items.getItem("coins") >= coinsRequired) {
            element.style.color = greenLabelColor;
            refresh_background(testingForBuyItem, true);
        } else {
            element.style.color = redLabelColor;
            refresh_background(testingForBuyItem, false);
        }
        element.innerHTML = originalLabel;
    }

    var labelGhostEssenceElements = document.querySelectorAll('[data-switch-label-color-ghostessence]')
    for(var i = 0; i < labelGhostEssenceElements.length; i++) {
        var element = labelGhostEssenceElements[i];
        var ghostEssenceRequired = element.innerHTML;
        var originalLabel = element.innerHTML;
        ghostEssenceRequired = ghostEssenceRequired.replaceAll(",", "");
        ghostEssenceRequired = get_number_with_letters(ghostEssenceRequired);
        if(Items.getItem("ghost_essence") >= ghostEssenceRequired) {
            element.style.color = "green";
        } else {
            element.style.color = "#EC8B8B";
        }
        element.innerHTML = originalLabel;
    }

    shop_items = ["pickaxe","wooden_sword", "wooden_bow", "wooden_staff", "arcade_ticket", "hammer", "arcade_ticket_2", "criptoe_market", "pirate", "player_market", "donor_shop", "coconut", "mirror", "crystal_ball", "pancakes", "dragon_bones"];

    community_center_requirements = {
        "arcade_ticket": "community_center_1",
        "hammer": "community_center_1",
        "coconut":"community_center_1",
        "arcade_ticket_2": "community_center_2",
        "pirate": "community_center_2",
        "mirror": "community_center_2",
        "pancakes": "community_center_3",
        "dragon_bones": "community_center_3",
        "crystal_ball": "community_center_3",
        "criptoe_market": "community_center_4",
    }

    for(var i = 0; i < shop_items.length; i++)
    {
        shop_item = shop_items[i];
        if(Items.getItem(shop_item + "_bought") > 0)
        {
            hide_element("shop-" + shop_item)
            continue;
        }

       if(community_center_requirements[shop_item] != null)
       {
            if(Items.getItem(community_center_requirements[shop_item]) >= 1)
                show_element("shop-" + shop_item);
            else
                hide_element("shop-" + shop_item);
       }
    }

    if(Items.getItem("pirate") >= 10)
        document.getElementById("shop-pirate").style.display = "none";

}

function refresh_merchant()
{
    if(Items.getItem("merchant_timer") > 0)
    {
        document.getElementById("shop-merchant-3").style.display = 'none';
        document.getElementById("shop-merchant-2").style.display = 'none';
        document.getElementById("shop-merchant-1").style.display = 'none';
    }

    for(var i = 1; i <= 3; i++)
    {
        if(Items.getItemString("merchant_selling_item_" + i) == "none") continue;
    
        document.getElementById("shop-merchant-" + i).style.display = '';

        var marchantSellItem = Items.getItemString('merchant_selling_item_' + i)
        var marchantSellAmount = Items.getItem("merchant_selling_item_amount_" + i);
        var barterItem = Items.getItemString('merchant_barter_item_' + i)
        var barterAmount = Items.getItem("merchant_barter_amount_" + i);

        document.getElementById("shop-merchant-"+i+"-image").src = 'https://cdn.idle-pixel.com/images/'+marchantSellItem+'.png'
        document.getElementById("shop-merchant-"+i+"-merchant-amount").innerHTML = format_number(marchantSellAmount);

        document.getElementById("shop-merchant-"+i+"-barter-image").src = 'https://cdn.idle-pixel.com/images/'+barterItem+'.png'

        if(Items.getItem(barterItem) >= barterAmount)
            document.getElementById("shop-merchant-"+i+"-barter-amount").innerHTML = "<span style='color:lime'>"+format_number(barterAmount)+"</span>";
        else
            document.getElementById("shop-merchant-"+i+"-barter-amount").innerHTML = "<span style='color:pink'>"+format_number(barterAmount)+"</span>";
    }
}

function get_sell_price(item)
{
    switch(item){
        case "stone":
        return 1;
        case "copper":
        return 2;
        case "iron":
        return 3;
        case "silver":
        return 5; 
        case "gold":
        return 10; 
        case "promethium":
        return 90; 
        case "titanium":
        return 300; 
        case "ancient_ore":
        return 1000; 

        case "bronze_bar":
        return 3; 
        case "iron_bar":
        return 5;   
        case "silver_bar":
        return 10; 
        case "gold_bar":
        return 50; 
        case "promethium_bar":
        return 1000; 
        case "titanium_bar":
        return 5000; 
        case "ancient_bar":
        return 25000;  
        case "mixed_bar":
        return 10000; 

        case "logs":
        return 10; 
        case "oak_logs":
        return 20; 
        case "willow_logs":
        return 30; 
        case "maple_logs":
        return 50; 
        case "stardust_logs":
        return 100; 
        case "pine_logs":
        return 200; 
        case "redwood_logs":
        return 500; 

        case "sapphire":
        return 10000; 
        case "emerald":
        return 25000; 
        case "ruby":
        return 50000; 
        case "diamond":
        return 100000; 
        case "blood_diamond":
        return 2500000; 


        default:
            return "not-implemented";
    }
}

function clicks_ghost_essence()
{
    var result = Quests.theMerchanterShowItem('ghost_essence')
    if(!result) {
        if(Items.getItem("mansion_shop") > 0) {
            switch_panels('panel-shop');
        }
    }
}